diff -pruN 59c-38/debian/changelog 59c-39/debian/changelog
--- 59c-38/debian/changelog	2024-07-04 23:02:41.000000000 +0000
+++ 59c-39/debian/changelog	2024-08-18 23:55:51.000000000 +0000
@@ -1,3 +1,26 @@
+mksh (59c-39) unstable; urgency=medium
+
+  [ Helmut Grohne ]
+  * move files from /bin/ to /usr/bin/ (Closes: #1073608)
+
+  [ Thorsten Glaser ]
+  * grudgingly merge the above
+  * the “2/2… who needs enemies” upload 😾
+  * drop the experimental changes
+  * upload to unstable
+  * merge from CVS HEAD:
+    - [komh] fix refactoro
+    - [komh] prefer .exe to .ksh in search order of the executable on OS/2
+    - [tg] add just another nanosecond variant: dietlibc has sb.st_mtime_nsec
+    - [tg] improve ENOEXEC scriptexec handling (whitelist cosmopolitan libc’s
+      “APE” executables; distinguish between bad magic and shebang too long;
+      avail on EBCDIC; fix errorlevel for wrong-arch ELF; recognise Zstd)
+    - [Riccardo Felici] improve syntax check for while/until loops
+  * Bump S-V, no changes
+  * Remove checks for nōn-UsrMove layout, now that this is forced upon users
+
+ -- Thorsten Glaser <tg@mirbsd.de>  Mon, 19 Aug 2024 01:55:51 +0200
+
 mksh (59c-38) experimental; urgency=low
 
   * experiments to deal with the poettering’d filesystem layout
diff -pruN 59c-38/debian/control 59c-39/debian/control
--- 59c-38/debian/control	2024-07-04 23:02:41.000000000 +0000
+++ 59c-39/debian/control	2024-08-18 23:19:24.000000000 +0000
@@ -15,15 +15,13 @@ Homepage: http://mirbsd.de/mksh
 # so I don’t do it as the spec forbids that.
 #
 Build-Depends: debhelper-compat (= 13), file,
-  gcc (>= 4:14), g++ (>= 4:14),
-  pax,
 # # libc variants to link against
-  dietlibc-dev (>= 0.34~cvs20160606-14exp) [alpha amd64 arm arm64 armeb armel armhf hppa i386 ia64 mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el s390 s390x sparc sparc64 x32],
+  dietlibc-dev [alpha amd64 arm arm64 armeb armel armhf hppa i386 ia64 mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el s390 s390x sparc sparc64 x32],
   libklibc-dev [alpha amd64 arm64 armel armhf hppa i386 ia64 loong64 m68k mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64 x32],
   musl-tools [amd64 arm64 armel armhf i386 loong64 m68k mips mips64el mipsel ppc64el riscv64 s390x sh4],
 # # to run the testsuite
   bsdextrautils, ed
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 VCS-git: https://evolvis.org/anonscm/git/alioth/mksh.git -b master
 VCS-Browser: https://evolvis.org/plugins/scmgit/cgi-bin/gitweb.cgi?p=alioth/mksh.git;a=shortlog;h=refs/heads/master
diff -pruN 59c-38/debian/meat 59c-39/debian/meat
--- 59c-38/debian/meat	2024-04-05 00:30:02.000000000 +0000
+++ 59c-39/debian/meat	2024-08-18 23:02:54.000000000 +0000
@@ -500,7 +500,7 @@ klibc_check_prereqs() {
 			return 1
 			;;
 		esac
-		extrareadme=$extrareadme'This build needs at least Linux 5.1.'$nl
+		extrareadme=$extrareadme'This build needs at least Linux 5.1 for klibc-built binaries.'$nl
 		kc_k=$(uname -r || echo FAIL)
 		case $kc_k in
 		([01234].*|5.0*)
diff -pruN 59c-38/debian/mkdeb 59c-39/debian/mkdeb
--- 59c-38/debian/mkdeb	2024-07-04 23:01:13.000000000 +0000
+++ 59c-39/debian/mkdeb	1970-01-01 00:00:00.000000000 +0000
@@ -1,56 +0,0 @@
-export LC_ALL=C
-unset LANGUAGE
-cf=control.tar.xz
-cc='xz -3e'
-df=data.tar.xz
-Dc='xz -7e'
-dc='xz -6e'
-set -exo pipefail
-reprodate=$(dpkg-parsechangelog -n1 | sed --posix -n '/^Date: */s///p')
-rm -rf debian/.debhelper/scratch-space/.mkdeb.t
-mkdir -p debian/.debhelper/scratch-space/.mkdeb.t
-
-if [[ -f debian/.debhelper/mksh/dbgsym-root/DEBIAN/control ]]; then
-	fp=$(sed -n '/^Package: /s///p' debian/.debhelper/mksh/dbgsym-root/DEBIAN/control)
-	fv=$(sed -n '/^Version: /s///p' debian/.debhelper/mksh/dbgsym-root/DEBIAN/control)
-	fa=$(sed -n '/^Architecture: /s///p' debian/.debhelper/mksh/dbgsym-root/DEBIAN/control)
-	pn=${fp}_${fv}_${fa}.deb
-	(cd debian/.debhelper/mksh/dbgsym-root/DEBIAN && \
-	    find . \! -type d -print0 | sort -z | \
-	    paxcpio -oC512 -Hustar -0M 0x010B) | \
-	    $cc >debian/.debhelper/scratch-space/.mkdeb.t/$cf
-	(cd debian/.debhelper/mksh/dbgsym-root && \
-	    find * -print0 | sort -z | grep -vz '^DEBIAN' | \
-	    paxcpio -oC512 -Hustar -0M 0x010B) | \
-	    $Dc >debian/.debhelper/scratch-space/.mkdeb.t/$df
-	(cd debian/.debhelper/scratch-space/.mkdeb.t && \
-	    echo 2.0 >debian-binary && \
-	    touch --date="$reprodate" debian-binary $cf $df && \
-	    paxtar -D ar -M dist -cf "$pn" debian-binary $cf $df)
-	mv debian/.debhelper/scratch-space/.mkdeb.t/"$pn" ../
-	touch --date="$reprodate" ../"$pn"
-	rm -rf debian/.debhelper/scratch-space/.mkdeb.t
-	mkdir -p debian/.debhelper/scratch-space/.mkdeb.t
-fi
-
-fp=$(sed -n '/^Package: /s///p' debian/mksh/DEBIAN/control)
-fv=$(sed -n '/^Version: /s///p' debian/mksh/DEBIAN/control)
-fa=$(sed -n '/^Architecture: /s///p' debian/mksh/DEBIAN/control)
-pn=${fp}_${fv}_${fa}.deb
-(cd debian/mksh/DEBIAN && \
-    find . \! -type d -print0 | sort -z | \
-    paxcpio -oC512 -Hustar -0M 0x010B) | \
-    $cc >debian/.debhelper/scratch-space/.mkdeb.t/$cf
-(cd debian/mksh && \
-    find . -regex '^\./[^/]+/.*$' -print0 | sort -z | \
-    grep -vz '^\./DEBIAN/' | \
-    paxcpio -oC512 -Hustar -0M 0x010B) | \
-    $dc >debian/.debhelper/scratch-space/.mkdeb.t/$df
-(cd debian/.debhelper/scratch-space/.mkdeb.t && \
-    echo 2.0 >debian-binary && \
-    touch --date="$reprodate" debian-binary $cf $df && \
-    paxtar -D ar -M dist -cf "$pn" debian-binary $cf $df)
-mv debian/.debhelper/scratch-space/.mkdeb.t/"$pn" ../
-touch --date="$reprodate" ../"$pn"
-rm -rf debian/.debhelper/scratch-space/.mkdeb.t
-exit 0
diff -pruN 59c-38/debian/mksh.NEWS 59c-39/debian/mksh.NEWS
--- 59c-38/debian/mksh.NEWS	2024-04-02 13:20:40.000000000 +0000
+++ 59c-39/debian/mksh.NEWS	2024-08-18 23:12:38.000000000 +0000
@@ -1,3 +1,15 @@
+mksh (59c-39) unstable; urgency=medium
+
+  This build is the first to move the binaries from their
+  canonical location in /bin/ to /usr/bin/ as mandated by
+  the Release Team. Helmut assures me that this move will
+  not cause users problems, so here’s to hoping.
+
+  Do note that dash broke things for us again (#1078130),
+  some manual work is necessary before upgrading. O “joy”…
+
+ -- Thorsten Glaser <tg@mirbsd.de>  Mon, 19 Aug 2024 01:09:02 +0200
+
 mksh (59c-3) unstable; urgency=medium
 
   mksh and lksh monitor the POSIX locale environment variables now
diff -pruN 59c-38/debian/mksh.lintian-overrides 59c-39/debian/mksh.lintian-overrides
--- 59c-38/debian/mksh.lintian-overrides	2024-07-04 23:01:13.000000000 +0000
+++ 59c-39/debian/mksh.lintian-overrides	2024-08-18 23:38:40.000000000 +0000
@@ -6,7 +6,7 @@
 mksh: statically-linked-binary [usr/lib/*]
 
 # lintian bug #1068304 on static-pie executables
-mksh: shared-library-lacks-prerequisites [bin/lksh]
+mksh: shared-library-lacks-prerequisites [usr/bin/lksh]
 mksh: shared-library-lacks-prerequisites [usr/lib/*-linux-musl*/bin/mksh]
 
 # see musl.lintian-overrides for the rationale
@@ -25,11 +25,13 @@ mksh: executable-in-usr-lib [usr/lib/kli
 mksh: executable-in-usr-lib [usr/lib/*-linux-musl*/bin/mksh]
 
 # these are to clean old add-shell(8) damage, not actually dereferenced
-mksh: bin-sbin-mismatch usr/bin/mksh* -> bin/mksh* [postinst]
-mksh: bin-sbin-mismatch usr/bin/mksh* -> bin/mksh* [prerm]
+mksh: bin-sbin-mismatch *bin/mksh* -> *bin/mksh* [postinst]
+mksh: bin-sbin-mismatch *bin/mksh* -> *bin/mksh* [prerm]
 
 # this field is new
 mksh: unknown-field Static-Built-Using
 
-# workaround for #1073608
-mksh: missing-intermediate-directory
+# bogus filesystem layout mandated by RT; the /bin/mksh path in the menu file is correct
+mksh: menu-command-not-in-package bin/mksh *
+# similarly, the #!/bin/mksh shebang is canonical
+mksh: bin-sbin-mismatch bin/mksh -> usr/bin/mksh [usr/share/doc/mksh/examples/uhr]
diff -pruN 59c-38/debian/mksh.postinst 59c-39/debian/mksh.postinst
--- 59c-38/debian/mksh.postinst	2024-04-03 16:24:10.000000000 +0000
+++ 59c-39/debian/mksh.postinst	2024-08-18 23:55:47.000000000 +0000
@@ -151,10 +151,8 @@ case $1 in
 	test -e /usr/bin/ksh || test -h /usr/bin/ksh || \
 	    ln -s /bin/ksh /usr/bin/ksh
 
-	# check for bogus filesystem layout; if so, also add
-	# nōn-canonical pathnames for popular demand
+	# also add nōn-canonical pathnames under /usr/bin/
 	um=+  # broken filesystem, unsupported by dpkg
-	test /usr/bin/mksh -ef /bin/mksh || um=- # traditional layout
 
 	# add us to /etc/shells and clean up old add-shell-caused damage
 	# shellcheck disable=SC2046
diff -pruN 59c-38/debian/patches/debian-changes 59c-39/debian/patches/debian-changes
--- 59c-38/debian/patches/debian-changes	2024-07-04 23:02:41.000000000 +0000
+++ 59c-39/debian/patches/debian-changes	2024-08-18 23:55:51.000000000 +0000
@@ -6,7 +6,7 @@ see the Vcs-* tags in debian/control for
 @@ -1,9 +1,10 @@
  #!/bin/sh
 -srcversion='$MirOS: src/bin/mksh/Build.sh,v 1.763 2020/09/04 21:01:37 tg Exp $'
-+srcversion='$MirOS: src/bin/mksh/Build.sh,v 1.856 2024/04/02 10:51:35 tg Exp $'
++srcversion='$MirOS: src/bin/mksh/Build.sh,v 1.858 2024/08/17 23:33:47 tg Exp $'
 +set +evx
  #-
  # Copyright (c) 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
@@ -35,8 +35,8 @@ see the Vcs-* tags in debian/control for
 +
 +	test x"$y" = x"0" && test x"$x" = x"$4" && return
 +	echo >&2 "E: your $1 does not work correctly!"
-+	echo >&2 "N: 'echo $2 | $3' exited $y and returned '$x' instead of '$4'"
-+	echo >&2 'N: install a better one and prepend e.g. /usr/local/bin to $PATH'
++	echo >&2 "N: 'echo $2 | $3' exited $y and returned '$x'; expected '$4'"
++	echo >&2 'N: install a better one and prepend its location to $PATH'
 +	exit 1
 +}
 +test_tool grep foobarbaz 'grep bar' foobarbaz
@@ -108,7 +108,19 @@ see the Vcs-* tags in debian/control for
  
  if test -t 1; then
  	bi='[1m'
-@@ -326,17 +356,28 @@ ac_testinit() {
+@@ -313,6 +343,11 @@ ac_testinit() {
+ 			shift
+ 		fi
+ 		eval ft=\$HAVE_`upper $2`
++		if test_z "$ft"; then
++			echo >&2
++			echo >&2 "E: test $f depends on $2 which is not defined yet"
++			exit 255
++		fi
+ 		shift
+ 	fi
+ 	fd=${3-$f}
+@@ -326,17 +361,28 @@ ac_testinit() {
  	return 0
  }
  
@@ -140,7 +152,7 @@ see the Vcs-* tags in debian/control for
  	test $tcfn = no && test -f a.out && tcfn=a.out
  	test $tcfn = no && test -f a.exe && tcfn=a.exe
  	test $tcfn = no && test -f conftest.exe && tcfn=conftest.exe
-@@ -348,18 +389,28 @@ ac_testnnd() {
+@@ -348,18 +394,28 @@ ac_testnnd() {
  	fi
  	vscan=
  	if test $phase = u; then
@@ -176,7 +188,7 @@ see the Vcs-* tags in debian/control for
  }
  
  # ac_ifcpp cppexpr [!] label [!] checkif[!]0 [setlabelifcheckis[!]0] useroutput
-@@ -384,6 +435,31 @@ EOF
+@@ -384,6 +440,31 @@ EOF
  	test x"$fv" = x"1"
  }
  
@@ -208,7 +220,7 @@ see the Vcs-* tags in debian/control for
  add_cppflags() {
  	CPPFLAGS="$CPPFLAGS $*"
  }
-@@ -392,7 +468,7 @@ ac_cppflags() {
+@@ -392,7 +473,7 @@ ac_cppflags() {
  	test x"$1" = x"" || fu=$1
  	fv=$2
  	test x"$2" = x"" && eval fv=\$HAVE_$fu
@@ -217,7 +229,7 @@ see the Vcs-* tags in debian/control for
  }
  
  ac_test() {
-@@ -424,7 +500,7 @@ ac_flags() {
+@@ -424,7 +505,7 @@ ac_flags() {
  		ac_testn can_$vn '' "$ft" <<-'EOF'
  			/* evil apo'stroph in comment test */
  			#include <unistd.h>
@@ -226,7 +238,7 @@ see the Vcs-* tags in debian/control for
  		EOF
  		#'
  	fi
-@@ -448,14 +524,17 @@ ac_header() {
+@@ -448,14 +529,17 @@ ac_header() {
  	do
  		case $i in
  		_time)
@@ -246,7 +258,7 @@ see the Vcs-* tags in debian/control for
  			;;
  		*)
  			echo "#include <$i>" >>x
-@@ -478,35 +557,62 @@ addsrcs() {
+@@ -478,35 +562,62 @@ addsrcs() {
  		fr=1
  	fi
  	eval i=\$$1
@@ -315,7 +327,7 @@ see the Vcs-* tags in debian/control for
  optflags=-std-compile-opts
  check_categories=
  last=
-@@ -518,7 +624,7 @@ ebcdic=false
+@@ -518,7 +629,7 @@ ebcdic=false
  for i
  do
  	case $last:$i in
@@ -324,7 +336,7 @@ see the Vcs-* tags in debian/control for
  		cm=$i
  		last=
  		;;
-@@ -530,6 +636,12 @@ do
+@@ -530,6 +641,12 @@ do
  		optflags=$i
  		last=
  		;;
@@ -337,7 +349,7 @@ see the Vcs-* tags in debian/control for
  	:-c)
  		last=c
  		;;
-@@ -543,7 +655,7 @@ do
+@@ -543,7 +660,7 @@ do
  	:-g)
  		# checker, debug, valgrind build
  		add_cppflags -DDEBUG
@@ -346,7 +358,7 @@ see the Vcs-* tags in debian/control for
  		;;
  	:-j)
  		pm=1
-@@ -577,7 +689,7 @@ do
+@@ -577,7 +694,7 @@ do
  		;;
  	:-v)
  		echo "Build.sh $srcversion"
@@ -355,7 +367,7 @@ see the Vcs-* tags in debian/control for
  		exit 0
  		;;
  	:*)
-@@ -604,8 +716,10 @@ if test -d $tfn || test -d $tfn.exe; the
+@@ -604,8 +721,10 @@ if test -d $tfn || test -d $tfn.exe; the
  	echo "$me: Error: ./$tfn is a directory!" >&2
  	exit 1
  fi
@@ -368,7 +380,7 @@ see the Vcs-* tags in debian/control for
  
  SRCS="lalloc.c edit.c eval.c exec.c expr.c funcs.c histrap.c jobs.c"
  SRCS="$SRCS lex.c main.c misc.c shf.c syn.c tree.c var.c"
-@@ -614,21 +728,21 @@ if test $legacy = 0; then
+@@ -614,21 +733,21 @@ if test $legacy = 0; then
  	check_categories="$check_categories shell:legacy-no int:32"
  else
  	check_categories="$check_categories shell:legacy-yes"
@@ -394,7 +406,7 @@ see the Vcs-* tags in debian/control for
  	CPPFLAGS="-I. $CPPFLAGS"
  else
  	CPPFLAGS="-I. -I'$srcdir' $CPPFLAGS"
-@@ -641,17 +755,30 @@ fi
+@@ -641,17 +760,30 @@ fi
  
  if test_z "$TARGET_OS"; then
  	x=`uname -s 2>/dev/null || uname`
@@ -427,7 +439,7 @@ see the Vcs-* tags in debian/control for
  
  # Evil hack
  if test x"$TARGET_OS" = x"Android"; then
-@@ -665,7 +792,7 @@ if test x"$TARGET_OS" = x"Minix"; then
+@@ -665,7 +797,7 @@ if test x"$TARGET_OS" = x"Minix"; then
  WARNING: additional checks before running Build.sh required!
  You can avoid these by calling Build.sh correctly, see below.
  "
@@ -436,7 +448,7 @@ see the Vcs-* tags in debian/control for
  #include <sys/types.h>
  const char *
  #ifdef _NETBSD_SOURCE
-@@ -676,7 +803,7 @@ ct="Minix3"
+@@ -676,7 +808,7 @@ ct="Minix3"
  ;
  EOF
  	ct=unknown
@@ -445,7 +457,7 @@ see the Vcs-* tags in debian/control for
  	sed 's/^/[ /' x
  	eval `cat x`
  	rmf x vv.out
-@@ -709,17 +836,31 @@ NEXTSTEP)
+@@ -709,17 +841,31 @@ NEXTSTEP)
  	    grep 'NeXT Mach [0-9][0-9.]*:' | \
  	    sed 's/^.*NeXT Mach \([0-9][0-9.]*\):.*$/\1/'`
  	;;
@@ -480,7 +492,7 @@ see the Vcs-* tags in debian/control for
  	;;
  A/UX)
  	add_cppflags -D_POSIX_SOURCE
-@@ -730,36 +871,54 @@ A/UX)
+@@ -730,36 +876,54 @@ A/UX)
  	;;
  AIX)
  	add_cppflags -D_ALL_SOURCE
@@ -547,7 +559,7 @@ see the Vcs-* tags in debian/control for
  	;;
  Darwin)
  	add_cppflags -D_DARWIN_C_SOURCE
-@@ -771,26 +930,24 @@ FreeBSD)
+@@ -771,26 +935,24 @@ FreeBSD)
  FreeMiNT)
  	oswarn="; it has minor issues"
  	add_cppflags -D_GNU_SOURCE
@@ -578,7 +590,7 @@ see the Vcs-* tags in debian/control for
  	HAVE_ISSET_MKSH_ASSUME_UTF8=1
  	HAVE_ISOFF_MKSH_ASSUME_UTF8=0
  	;;
-@@ -800,42 +957,52 @@ Harvey)
+@@ -800,42 +962,52 @@ Harvey)
  	add_cppflags -D_BSD_EXTENSION
  	add_cppflags -D_SUSV2_SOURCE
  	add_cppflags -D_GNU_SOURCE
@@ -644,7 +656,7 @@ see the Vcs-* tags in debian/control for
  	add_cppflags '-D_PATH_DEFPATH=\"/cmd\"'
  	add_cppflags '-DMKSH_DEFAULT_EXECSHELL=\"/cmd/mksh\"'
  	add_cppflags '-DMKSH_DEFAULT_PROFILEDIR=\"/cfg/mksh\"'
-@@ -847,7 +1014,7 @@ Linux)
+@@ -847,7 +1019,7 @@ Linux)
  	*tendracc*) ;;
  	*) add_cppflags -D_GNU_SOURCE ;;
  	esac
@@ -653,7 +665,7 @@ see the Vcs-* tags in debian/control for
  	: "${HAVE_REVOKE=0}"
  	;;
  LynxOS)
-@@ -861,26 +1028,33 @@ midipix)
+@@ -861,26 +1033,33 @@ midipix)
  MidnightBSD)
  	;;
  Minix-vmd)
@@ -694,7 +706,7 @@ see the Vcs-* tags in debian/control for
  	# broken on this OE (from ir0nh34d)
  	: "${HAVE_STDINT_H=0}"
  	;;
-@@ -890,10 +1064,10 @@ NEXTSTEP)
+@@ -890,10 +1069,10 @@ NEXTSTEP)
  	add_cppflags -D_NEXT_SOURCE
  	add_cppflags -D_POSIX_SOURCE
  	: "${AWK=gawk}"
@@ -708,7 +720,7 @@ see the Vcs-* tags in debian/control for
  	case $TARGET_OSREV in
  	4.2*)
  		# OpenStep 4.2 is broken by default
-@@ -903,27 +1077,28 @@ NEXTSTEP)
+@@ -903,27 +1082,28 @@ NEXTSTEP)
  	;;
  Ninix3)
  	# similar to Minix3
@@ -744,7 +756,7 @@ see the Vcs-* tags in debian/control for
  	: "${MKSH_UNLIMITED=1}"
  	if test $textmode = 0; then
  		x='dis'
-@@ -948,13 +1123,15 @@ the mksh-os2 porter.
+@@ -948,13 +1128,15 @@ the mksh-os2 porter.
  "
  	;;
  OS/390)
@@ -762,7 +774,7 @@ see the Vcs-* tags in debian/control for
  	oswarn='; EBCDIC support is incomplete'
  	;;
  OSF1)
-@@ -963,29 +1140,31 @@ OSF1)
+@@ -963,29 +1145,31 @@ OSF1)
  	add_cppflags -D_POSIX_C_SOURCE=200112L
  	add_cppflags -D_XOPEN_SOURCE=600
  	add_cppflags -D_XOPEN_SOURCE_EXTENDED
@@ -802,7 +814,7 @@ see the Vcs-* tags in debian/control for
  	;;
  QNX)
  	add_cppflags -D__NO_EXT_QNX
-@@ -995,13 +1174,21 @@ QNX)
+@@ -995,13 +1179,21 @@ QNX)
  		oldish_ed=no-stderr-ed		# oldish /bin/ed is broken
  		;;
  	esac
@@ -826,7 +838,7 @@ see the Vcs-* tags in debian/control for
  		;;
  	5*)
  		# SCO OpenServer 6
-@@ -1013,6 +1200,16 @@ SCO_SV)
+@@ -1013,6 +1205,16 @@ SCO_SV)
  	esac
  	: "${HAVE_SYS_SIGLIST=0}${HAVE__SYS_SIGLIST=0}"
  	;;
@@ -843,7 +855,7 @@ see the Vcs-* tags in debian/control for
  skyos)
  	oswarn="; it has minor issues"
  	;;
-@@ -1022,13 +1219,13 @@ SunOS)
+@@ -1022,13 +1224,13 @@ SunOS)
  	;;
  syllable)
  	add_cppflags -D_GNU_SOURCE
@@ -861,7 +873,7 @@ see the Vcs-* tags in debian/control for
  	;;
  UnixWare|UNIX_SV)
  	# SCO UnixWare
-@@ -1040,21 +1237,41 @@ UWIN*)
+@@ -1040,21 +1242,41 @@ UWIN*)
  	tsts=" 3<>/dev/tty"
  	oswarn="; it will compile, but the target"
  	oswarn="$oswarn${nl}platform itself is very flakey/unreliable"
@@ -909,7 +921,7 @@ see the Vcs-* tags in debian/control for
  
  : "${AWK=awk}${CC=cc}${NROFF=nroff}${SIZE=size}"
  test 0 = $r && echo | $NROFF -v 2>&1 | grep GNU >/dev/null 2>&1 && \
-@@ -1085,7 +1302,7 @@ OSF1)
+@@ -1085,7 +1307,7 @@ OSF1)
  	vv '|' "uname -a >&2"
  	vv '|' "/usr/sbin/sizer -v >&2"
  	;;
@@ -918,7 +930,7 @@ see the Vcs-* tags in debian/control for
  	vv '|' "uname -a >&2"
  	vv '|' "uname -X >&2"
  	;;
-@@ -1094,13 +1311,18 @@ SCO_SV|UnixWare|UNIX_SV)
+@@ -1094,13 +1316,18 @@ SCO_SV|UnixWare|UNIX_SV)
  	;;
  esac
  test_z "$oswarn" || echo >&2 "
@@ -943,7 +955,7 @@ see the Vcs-* tags in debian/control for
  
  #
  # Start of mirtoconf checks
-@@ -1117,7 +1339,7 @@ $e $bi$me: Scanning for functions... ple
+@@ -1117,7 +1344,7 @@ $e $bi$me: Scanning for functions... ple
  # - nwcc defines __GNUC__ too
  CPP="$CC -E"
  $e ... which compiler type seems to be used
@@ -952,7 +964,7 @@ see the Vcs-* tags in debian/control for
  const char *
  #if defined(__ICC) || defined(__INTEL_COMPILER)
  ct="icc"
-@@ -1163,6 +1385,8 @@ ct="tcc"
+@@ -1163,6 +1390,8 @@ ct="tcc"
  ct="clang"
  #elif defined(__NWCC__)
  ct="nwcc"
@@ -961,7 +973,7 @@ see the Vcs-* tags in debian/control for
  #elif defined(__GNUC__)
  ct="gcc"
  #elif defined(_COMPILER_VERSION)
-@@ -1177,9 +1401,13 @@ ct="ucode"
+@@ -1177,9 +1406,13 @@ ct="ucode"
  ct="uslc"
  #elif defined(__LCC__)
  ct="lcc"
@@ -975,7 +987,7 @@ see the Vcs-* tags in debian/control for
  #else
  ct="unknown"
  #endif
-@@ -1187,6 +1415,8 @@ ct="unknown"
+@@ -1187,6 +1420,8 @@ ct="unknown"
  const char *
  #if defined(__KLIBC__) && !defined(__OS2__)
  et="klibc"
@@ -984,7 +996,7 @@ see the Vcs-* tags in debian/control for
  #else
  et="unknown"
  #endif
-@@ -1194,24 +1424,43 @@ et="unknown"
+@@ -1194,24 +1429,43 @@ et="unknown"
  EOF
  ct=untested
  et=untested
@@ -1031,7 +1043,7 @@ see the Vcs-* tags in debian/control for
      own risk, please report success/failure to the developers.'
  	;;
  bcc)
-@@ -1221,10 +1470,9 @@ bcc)
+@@ -1221,10 +1475,9 @@ bcc)
  	;;
  clang)
  	# does not work with current "ccc" compiler driver
@@ -1043,7 +1055,7 @@ see the Vcs-* tags in debian/control for
  	# ensure compiler and linker are in sync unless overridden
  	case $CCC_CC:$CCC_LD in
  	:*)	;;
-@@ -1233,8 +1481,9 @@ clang)
+@@ -1233,8 +1486,9 @@ clang)
  	: "${HAVE_STRING_POOLING=i1}"
  	;;
  dec)
@@ -1055,7 +1067,7 @@ see the Vcs-* tags in debian/control for
  	;;
  dmc)
  	echo >&2 "Warning: Digital Mars Compiler detected. When running under"
-@@ -1242,41 +1491,58 @@ dmc)
+@@ -1242,41 +1496,58 @@ dmc)
  	echo >&2 "    of this platform. Continue at your own risk,"
  	echo >&2 "    please report success/failure to the developers."
  	;;
@@ -1125,7 +1137,7 @@ see the Vcs-* tags in debian/control for
  	;;
  msc)
  	ccpr=		# errorlevels are not reliable
-@@ -1298,41 +1564,51 @@ msc)
+@@ -1298,41 +1569,51 @@ msc)
  	esac
  	;;
  neatcc)
@@ -1190,7 +1202,7 @@ see the Vcs-* tags in debian/control for
  	;;
  uslc)
  	case $TARGET_OS:$TARGET_OSREV in
-@@ -1342,32 +1618,52 @@ uslc)
+@@ -1342,32 +1623,52 @@ uslc)
  		: "${HAVE_CAN_OTWO=0}${HAVE_CAN_OPTIMISE=0}"
  		;;
  	esac
@@ -1249,7 +1261,7 @@ see the Vcs-* tags in debian/control for
  	: "${MKSH_UNLIMITED=1}"
  	;;
  unknown)
-@@ -1453,6 +1749,10 @@ msc)
+@@ -1453,6 +1754,10 @@ msc)
  	save_NOWARN="${ccpc}/w"
  	DOWARN="${ccpc}/WX"
  	;;
@@ -1260,7 +1272,7 @@ see the Vcs-* tags in debian/control for
  sunpro)
  	test x"$save_NOWARN" = x"" && save_NOWARN='-errwarn=%none'
  	ac_flags 0 errwarnnone "$save_NOWARN"
-@@ -1505,7 +1805,7 @@ hpcc)
+@@ -1505,7 +1810,7 @@ hpcc)
  	ac_flags 1 otwo +O2
  	phase=x
  	;;
@@ -1269,7 +1281,7 @@ see the Vcs-* tags in debian/control for
  	# no special optimisation
  	;;
  sunpro)
-@@ -1525,7 +1825,16 @@ xlc)
+@@ -1525,7 +1830,16 @@ xlc)
  	test 1 = $HAVE_CAN_OTHREE || ac_flags 1 otwo -O2
  	;;
  *)
@@ -1287,7 +1299,7 @@ see the Vcs-* tags in debian/control for
  	test 1 = $HAVE_CAN_OTWO || ac_flags 1 optimise -O
  	;;
  esac
-@@ -1546,18 +1855,28 @@ dmc)
+@@ -1546,18 +1860,28 @@ dmc)
  	ac_flags 1 decl "${ccpc}-r" 'for strict prototype checks'
  	ac_flags 1 schk "${ccpc}-s" 'for stack overflow checking'
  	;;
@@ -1318,7 +1330,7 @@ see the Vcs-* tags in debian/control for
  	*\ -fplugin=*dragonegg*) ;;
  	*) ac_flags 1 fplugin_dragonegg -fplugin=dragonegg ;;
  	esac
-@@ -1618,6 +1937,9 @@ icc)
+@@ -1618,6 +1942,9 @@ icc)
  	;;
  mipspro)
  	ac_flags 1 fullwarn -fullwarn 'for remark output support'
@@ -1328,7 +1340,7 @@ see the Vcs-* tags in debian/control for
  	;;
  msc)
  	ac_flags 1 strpool "${ccpc}/GF" 'if string pooling can be enabled'
-@@ -1680,7 +2002,7 @@ if test 1 = $i; then
+@@ -1680,7 +2007,7 @@ if test 1 = $i; then
  fi
  
  # “on demand” means: GCC version >= 4
@@ -1337,7 +1349,7 @@ see the Vcs-* tags in debian/control for
  ac_cache string_pooling || case $HAVE_STRING_POOLING in
  2) fx=' (on demand, cached)' ;;
  i1) fv=1 ;;
-@@ -1697,12 +2019,7 @@ test $ct = pcc && phase=u
+@@ -1697,12 +2024,8 @@ test $ct = pcc && phase=u
  #
  # Compiler: check for stuff that only generates warnings
  #
@@ -1347,11 +1359,12 @@ see the Vcs-* tags in debian/control for
 -	/* force a failure: TenDRA and gcc 1.42 have false positive here */
 -	int main(void) { return (thiswillneverbedefinedIhope()); }
 -	#else
++: "${HAVE_ATTRIBUTE_EXTENSION=1}" # not a separate test but a dependency
 +ac_test attribute_bounded attribute_extension 0 'for __attribute__((__bounded__))' <<-'EOF'
  	#include <string.h>
  	#undef __attribute__
  	int xcopy(const void *, void *, size_t)
-@@ -1716,14 +2033,8 @@ ac_test attribute_bounded '' 'for __attr
+@@ -1716,14 +2039,8 @@ ac_test attribute_bounded '' 'for __attr
  		 */
  		memmove(d, s, n); return ((int)n);
  	}
@@ -1367,7 +1380,7 @@ see the Vcs-* tags in debian/control for
  	#define fprintf printfoo
  	#include <stdio.h>
  	#undef __attribute__
-@@ -1731,57 +2042,25 @@ ac_test attribute_format '' 'for __attri
+@@ -1731,57 +2048,25 @@ ac_test attribute_format '' 'for __attri
  	extern int fprintf(FILE *, const char *format, ...)
  	    __attribute__((__format__(__printf__, 2, 3)));
  	int main(int ac, char *av[]) { return (fprintf(stderr, "%s%d", *av, ac)); }
@@ -1386,7 +1399,7 @@ see the Vcs-* tags in debian/control for
  	int main(void) { fnord(); }
  	void fnord(void) { exit(0); }
 -	#endif
- EOF
+-EOF
 -ac_test attribute_pure '' 'for __attribute__((__pure__))' <<-'EOF'
 -	#if defined(__TenDRA__) || (defined(__GNUC__) && (__GNUC__ < 2))
 -	extern int thiswillneverbedefinedIhope(void);
@@ -1399,7 +1412,7 @@ see the Vcs-* tags in debian/control for
 -	int main(int ac, char *av[]) { return (foo(av[ac - 1]) + isatty(0)); }
 -	int foo(const char *s) { return ((int)s[0]); }
 -	#endif
--EOF
+ EOF
 -ac_test attribute_unused '' 'for __attribute__((__unused__))' <<-'EOF'
 -	#if defined(__TenDRA__) || (defined(__GNUC__) && (__GNUC__ < 2))
 -	extern int thiswillneverbedefinedIhope(void);
@@ -1428,7 +1441,7 @@ see the Vcs-* tags in debian/control for
  EOF
  
  # End of tests run with -Werror
-@@ -1807,7 +2086,7 @@ ac_ifcpp 'ifdef MKSH_NOPROSPECTOFWORK' i
+@@ -1807,7 +2092,7 @@ ac_ifcpp 'ifdef MKSH_NOPROSPECTOFWORK' i
      "if mksh will be built without job signals" && \
      check_categories="$check_categories arge nojsig"
  ac_ifcpp 'ifdef MKSH_ASSUME_UTF8' isset_MKSH_ASSUME_UTF8 '' \
@@ -1437,7 +1450,7 @@ see the Vcs-* tags in debian/control for
  ac_ifcpp 'if !MKSH_ASSUME_UTF8' isoff_MKSH_ASSUME_UTF8 \
      isset_MKSH_ASSUME_UTF8 0 \
      'if the default UTF-8 mode is disabled' && \
-@@ -1833,15 +2112,24 @@ ac_test both_time_h '' 'whether <sys/tim
+@@ -1833,15 +2118,24 @@ ac_test both_time_h '' 'whether <sys/tim
  	#include <sys/time.h>
  	#include <time.h>
  	#include <unistd.h>
@@ -1464,7 +1477,7 @@ see the Vcs-* tags in debian/control for
  ac_header sys/sysmacros.h
  ac_header bstring.h
  ac_header grp.h sys/types.h
-@@ -1854,18 +2142,16 @@ ac_header stdint.h stdarg.h
+@@ -1854,18 +2148,16 @@ ac_header stdint.h stdarg.h
  ac_header strings.h sys/types.h string.h
  ac_header termios.h
  ac_header ulimit.h sys/types.h
@@ -1487,7 +1500,7 @@ see the Vcs-* tags in debian/control for
  ac_testn can_lfs '' "for large file support" <lft.c
  save_CPPFLAGS=$CPPFLAGS
  add_cppflags -D_FILE_OFFSET_BITS=64
-@@ -1882,25 +2168,35 @@ rmf lft*	# end of large file support tes
+@@ -1882,25 +2174,35 @@ rmf lft*	# end of large file support tes
  #
  # Environment: types
  #
@@ -1537,7 +1550,7 @@ see the Vcs-* tags in debian/control for
  EOF
  
  # only testn: added later below
-@@ -1920,7 +2216,7 @@ ac_testn sighandler_t '!' sig_t 0 <<-'EO
+@@ -1920,7 +2222,7 @@ ac_testn sighandler_t '!' sig_t 0 <<-'EO
  	int main(void) { return (foo == (sighandler_t)0); }
  EOF
  if test 1 = $HAVE_SIGHANDLER_T; then
@@ -1546,7 +1559,7 @@ see the Vcs-* tags in debian/control for
  	HAVE_SIG_T=1
  fi
  
-@@ -1932,11 +2228,11 @@ ac_testn __sighandler_t '!' sig_t 0 <<-'
+@@ -1932,11 +2234,11 @@ ac_testn __sighandler_t '!' sig_t 0 <<-'
  	int main(void) { return (foo == (__sighandler_t)0); }
  EOF
  if test 1 = $HAVE___SIGHANDLER_T; then
@@ -1560,7 +1573,7 @@ see the Vcs-* tags in debian/control for
  ac_cppflags SIG_T
  
  #
-@@ -1946,13 +2242,17 @@ if test $cm = makefile; then
+@@ -1946,13 +2248,17 @@ if test $cm = makefile; then
  	: nothing to check
  else
  	HAVE_LINK_WORKS=x
@@ -1579,7 +1592,7 @@ see the Vcs-* tags in debian/control for
  		int main(void) {
  			struct timeval tv;
  			printf("Hello, World!\\n");
-@@ -1961,27 +2261,33 @@ else
+@@ -1961,27 +2267,33 @@ else
  EOF
  	case $cm in
  	llvm)
@@ -1620,7 +1633,7 @@ see the Vcs-* tags in debian/control for
  	esac
  	test -f $tcfn || fv=0
  	ac_testdone
-@@ -1991,43 +2297,65 @@ fi
+@@ -1991,43 +2303,65 @@ fi
  #
  # Environment: errors and signals
  #
@@ -1696,7 +1709,7 @@ see the Vcs-* tags in debian/control for
  	fi
  	ac_cppflags SYS_SIG$uwhat
  done
-@@ -2067,16 +2395,19 @@ ac_test rlimit '' 'getrlimit and setrlim
+@@ -2067,16 +2401,19 @@ ac_test rlimit '' 'getrlimit and setrlim
  	}
  EOF
  
@@ -1719,7 +1732,7 @@ see the Vcs-* tags in debian/control for
  	#if HAVE_SYS_RESOURCE_H
  	#include <sys/resource.h>
  	#endif
-@@ -2084,6 +2415,95 @@ ac_test rlim_t rlimit 0 <<-'EOF'
+@@ -2084,6 +2421,95 @@ ac_test rlim_t rlimit 0 <<-'EOF'
  	int main(void) { return (((int)(rlim_t)0) + isatty(0)); }
  EOF
  
@@ -1815,7 +1828,7 @@ see the Vcs-* tags in debian/control for
  ac_test getrusage <<-'EOF'
  	#define MKSH_INCLUDES_ONLY
  	#include "sh.h"
-@@ -2122,6 +2542,7 @@ ac_test memmove <<-'EOF'
+@@ -2122,6 +2548,7 @@ ac_test memmove <<-'EOF'
  	}
  EOF
  
@@ -1823,7 +1836,7 @@ see the Vcs-* tags in debian/control for
  ac_test mknod '' 'if to use mknod(), makedev() and friends' <<-'EOF'
  	#define MKSH_INCLUDES_ONLY
  	#include "sh.h"
-@@ -2144,7 +2565,7 @@ ac_test mmap lock_fcntl 0 'for mmap and
+@@ -2144,7 +2571,7 @@ ac_test mmap lock_fcntl 0 'for mmap and
  	#include <stddef.h>
  	#include <stdlib.h>
  	int main(void) { return ((void *)mmap(NULL, (size_t)0,
@@ -1832,7 +1845,7 @@ see the Vcs-* tags in debian/control for
  	    munmap(NULL, 0)); }
  EOF
  
-@@ -2158,6 +2579,13 @@ ac_test nice <<-'EOF'
+@@ -2158,6 +2585,13 @@ ac_test nice <<-'EOF'
  	int main(void) { return (nice(4)); }
  EOF
  
@@ -1846,7 +1859,7 @@ see the Vcs-* tags in debian/control for
  ac_test revoke <<-'EOF'
  	#include <sys/types.h>
  	#if HAVE_LIBUTIL_H
-@@ -2167,34 +2595,33 @@ ac_test revoke <<-'EOF'
+@@ -2167,34 +2601,33 @@ ac_test revoke <<-'EOF'
  	int main(int ac, char *av[]) { return (ac + revoke(av[0])); }
  EOF
  
@@ -1892,7 +1905,7 @@ see the Vcs-* tags in debian/control for
  	#if HAVE_BSTRING_H
  	#include <bstring.h>
  	#endif
-@@ -2227,6 +2654,23 @@ ac_test setgroups setresugid 0 <<-'EOF'
+@@ -2227,6 +2660,23 @@ ac_test setgroups setresugid 0 <<-'EOF'
  	int main(void) { gid_t gid = 0; return (setgroups(0, &gid)); }
  EOF
  
@@ -1916,7 +1929,7 @@ see the Vcs-* tags in debian/control for
  if test x"$et" = x"klibc"; then
  
  	ac_testn __rt_sigsuspend '' 'whether klibc uses RT signals' <<-'EOF'
-@@ -2255,16 +2699,16 @@ EOF
+@@ -2255,16 +2705,16 @@ EOF
  
  	if test "000" = "$HAVE___RT_SIGSUSPEND$HAVE___SIGSUSPEND_S$HAVE___SIGSUSPEND_XXS"; then
  		# no usable sigsuspend(), use pause() *ugh*
@@ -1936,7 +1949,7 @@ see the Vcs-* tags in debian/control for
  	#include <string.h>
  	#include <signal.h>
  	int main(void) { return (strsignal(1)[0]); }
-@@ -2276,6 +2720,11 @@ ac_test strlcpy <<-'EOF'
+@@ -2276,6 +2726,11 @@ ac_test strlcpy <<-'EOF'
  	    (size_t)ac)); }
  EOF
  
@@ -1948,7 +1961,7 @@ see the Vcs-* tags in debian/control for
  #
  # check headers for declarations
  #
-@@ -2303,15 +2752,40 @@ ac_test sys_siglist_decl sys_siglist 0 '
+@@ -2303,15 +2758,49 @@ ac_test sys_siglist_decl sys_siglist 0 '
  	int main(void) { return (sys_siglist[0][0] + isatty(0)); }
  EOF
  
@@ -1977,12 +1990,21 @@ see the Vcs-* tags in debian/control for
 +	cpp_define st_mtimensec st_mtim.tv_nsec
 +	HAVE_ST_MTIMENSEC=1
 +fi
-+ac_cppflags ST_MTIMENSEC
-+
-+ac_test intconstexpr_rsize_max '' 'whether RSIZE_MAX is an integer constant expression' <<-'EOF'
++ac_testn st_mtime_nsec '!' st_mtimensec 0 'for struct stat.st_mtime_nsec' <<-'EOF'
  	#define MKSH_INCLUDES_ONLY
  	#include "sh.h"
 -	int main(void) { struct stat sb; return (sizeof(sb.st_mtimensec)); }
++	int main(void) { struct stat sb; return (sizeof(sb.st_mtime_nsec)); }
++EOF
++if test 1 = "$HAVE_ST_MTIME_NSEC"; then
++	cpp_define st_mtimensec st_mtime_nsec
++	HAVE_ST_MTIMENSEC=1
++fi
++ac_cppflags ST_MTIMENSEC
++
++ac_test intconstexpr_rsize_max '' 'whether RSIZE_MAX is an integer constant expression' <<-'EOF'
++	#define MKSH_INCLUDES_ONLY
++	#include "sh.h"
 +	int tstarr[((int)(RSIZE_MAX) & 1) + 1] = {0};
 +	mbCTA_BEG(conftest_c);
 +	 mbCTA(rsizemax_check,
@@ -1992,7 +2014,7 @@ see the Vcs-* tags in debian/control for
  EOF
  
  #
-@@ -2335,12 +2809,13 @@ if test $legacy = 1; then
+@@ -2335,12 +2824,13 @@ if test $legacy = 1; then
  		#ifndef CHAR_BIT
  		#define CHAR_BIT 0
  		#endif
@@ -2012,7 +2034,7 @@ see the Vcs-* tags in debian/control for
  EOF
  
  	ac_test long_64bit '!' long_32bit 0 'whether long is 64 bit wide' <<-'EOF'
-@@ -2349,12 +2824,13 @@ EOF
+@@ -2349,12 +2839,13 @@ EOF
  		#ifndef CHAR_BIT
  		#define CHAR_BIT 0
  		#endif
@@ -2032,7 +2054,7 @@ see the Vcs-* tags in debian/control for
  EOF
  
  	case $HAVE_LONG_32BIT$HAVE_LONG_64BIT in
-@@ -2367,10 +2843,10 @@ fi
+@@ -2367,10 +2858,10 @@ fi
  #
  # Compiler: Praeprocessor (only if needed)
  #
@@ -2045,7 +2067,7 @@ see the Vcs-* tags in debian/control for
  	grep '#define foo bar' x >/dev/null 2>&1 && fv=1
  	rmf conftest.c x vv.out
  	ac_testdone
-@@ -2388,7 +2864,7 @@ ed x <x 2>/dev/null | grep 3 >/dev/null
+@@ -2388,7 +2879,7 @@ ed x <x 2>/dev/null | grep 3 >/dev/null
      check_categories="$check_categories $oldish_ed"
  rmf x vv.out
  
@@ -2054,7 +2076,7 @@ see the Vcs-* tags in debian/control for
  	if test 1 = $HAVE_CPP_DD; then
  		$e Generating list of signal names...
  	else
-@@ -2407,15 +2883,12 @@ if test 0 = $HAVE_SYS_SIGNAME; then
+@@ -2407,15 +2898,12 @@ if test 0 = $HAVE_SYS_SIGNAME; then
  #define cfg_NSIG (SIGMAX + 1)
  #elif defined(_SIGMAX)
  #define cfg_NSIG (_SIGMAX + 1)
@@ -2072,7 +2094,7 @@ see the Vcs-* tags in debian/control for
  	    grep -v '^#' | \
  	    sed '/mksh_cfg.*= *$/{
  		N
-@@ -2436,8 +2909,9 @@ mksh_cfg= cfg_NSIG
+@@ -2436,8 +2924,9 @@ mksh_cfg= cfg_NSIG
  	sigs="$sigs STOP TSTP TTIN TTOU USR1 USR2 POLL PROF SYS TRAP URG VTALRM"
  	sigs="$sigs XCPU XFSZ INFO WINCH EMT IO DIL LOST PWR SAK CLD IOT STKFLT"
  	sigs="$sigs ABND DCE DUMP IOERR TRACE DANGER THCONT THSTOP RESV UNUSED"
@@ -2083,7 +2105,7 @@ see the Vcs-* tags in debian/control for
  	    grep '[	 ]SIG[A-Z0-9][A-Z0-9]*[	 ]' | \
  	    sed 's/^.*[	 ]SIG\([A-Z0-9][A-Z0-9]*\)[	 ].*$/\1/' | sort`
  	test $NSIG -gt 1 || sigs=
-@@ -2451,7 +2925,7 @@ mksh_cfg= cfg_NSIG
+@@ -2451,7 +2940,7 @@ mksh_cfg= cfg_NSIG
  		echo mksh_cfg= SIG$name >>conftest.c
  		echo ';' >>conftest.c
  		# GNU sed 2.03 croaks on optimising this, too
@@ -2092,7 +2114,7 @@ see the Vcs-* tags in debian/control for
  		    grep -v '^#' | \
  		    sed '/mksh_cfg.*= *$/{
  			N
-@@ -2474,14 +2948,17 @@ mksh_cfg= cfg_NSIG
+@@ -2474,14 +2963,17 @@ mksh_cfg= cfg_NSIG
  	$e done.
  fi
  
@@ -2112,7 +2134,7 @@ see the Vcs-* tags in debian/control for
  else
  	USE_PRINTF_BUILTIN=0
  fi
-@@ -2491,41 +2968,38 @@ addsrcs USE_PRINTF_BUILTIN printf.c
+@@ -2491,41 +2983,38 @@ addsrcs USE_PRINTF_BUILTIN printf.c
  addsrcs '!' MKSH_UNLIMITED ulimit.c
  
  test 1 = "$HAVE_CAN_VERB" && CFLAGS="$CFLAGS -verbose"
@@ -2164,7 +2186,7 @@ see the Vcs-* tags in debian/control for
  	(P)	Pflag=1 ;;
  	(+P)	Pflag=0 ;;
  	(p)	pflag=\$OPTARG ;;
-@@ -2546,6 +3020,11 @@ cat >test.sh <<-EOF
+@@ -2546,6 +3035,11 @@ cat >test.sh <<-EOF
  	if $ebcdic; then
  		args[\${#args[*]}]=-E
  	fi
@@ -2176,7 +2198,7 @@ see the Vcs-* tags in debian/control for
  	x=
  	for y in "\${check_categories[@]}"; do
  		x=\$x,\$y
-@@ -2574,7 +3053,7 @@ cat >test.sh <<-EOF
+@@ -2574,7 +3068,7 @@ cat >test.sh <<-EOF
  		args[\${#args[*]}]=\$TMPDIR
  	fi
  	print Testing mksh for conformance:
@@ -2185,7 +2207,7 @@ see the Vcs-* tags in debian/control for
  	print "This shell is actually:\\n\\t\$KSH_VERSION"
  	print 'test.sh built for mksh $dstversion'
  	cstr='\$os = defined \$^O ? \$^O : "unknown";'
-@@ -2622,9 +3101,7 @@ llvm)
+@@ -2622,9 +3116,7 @@ llvm)
  	;;
  esac
  echo ": # work around NeXTstep bug" >Rebuild.sh
@@ -2196,7 +2218,7 @@ see the Vcs-* tags in debian/control for
  for file in $optfiles; do
  	echo "echo + Running genopt on '$file'..."
  	echo "(srcfile='$srcdir/$file'; BUILDSH_RUN_GENOPT=1; . '$srcdir/Build.sh')"
-@@ -2633,16 +3110,16 @@ echo set -x >>Rebuild.sh
+@@ -2633,16 +3125,16 @@ echo set -x >>Rebuild.sh
  for file in $SRCS; do
  	op=`echo x"$file" | sed 's/^x\(.*\)\.c$/\1./'`
  	test -f $file || file=$srcdir/$file
@@ -2218,7 +2240,7 @@ see the Vcs-* tags in debian/control for
  done
  case $cm in
  dragonegg|llvm)
-@@ -2654,41 +3131,54 @@ dragonegg|llvm)
+@@ -2654,41 +3146,54 @@ dragonegg|llvm)
  	lobjs=$objs
  	;;
  esac
@@ -2287,7 +2309,7 @@ see the Vcs-* tags in debian/control for
  #\$(PROG): \$(OBJS_BP)
  #	\$(CC) \$(CFLAGS) \$(LDFLAGS) -o \$@ \$(OBJS_BP) \$(LIBS)
  #\$(OBJS_BP): \$(SRCS_FP) \$(NONSRCS)
-@@ -2698,11 +3188,18 @@ LIBS=		$LIBS
+@@ -2698,11 +3203,18 @@ LIBS=		$LIBS
  # for all make variants:
  #REGRESS_FLAGS=	-f
  #regress:
@@ -2308,7 +2330,7 @@ see the Vcs-* tags in debian/control for
  #.include <bsd.prog.mk>
  EOF
  	$e
-@@ -2713,18 +3210,22 @@ for file in $optfiles; do
+@@ -2713,18 +3225,22 @@ for file in $optfiles; do
  	$e "+ Running genopt on '$file'..."
  	do_genopt "$srcdir/$file" || exit 1
  done
@@ -2334,7 +2356,7 @@ see the Vcs-* tags in debian/control for
  	done
  	wait
  else
-@@ -2732,7 +3233,7 @@ else
+@@ -2732,7 +3248,7 @@ else
  		test $cm = dragonegg && \
  		    op=`echo x"$file" | sed 's/^x\(.*\)\.c$/\1./'`
  		test -f $file || file=$srcdir/$file
@@ -2343,7 +2365,7 @@ see the Vcs-* tags in debian/control for
  		if test $cm = dragonegg; then
  			v "mv ${op}s ${op}ll"
  			v "llvm-as ${op}ll" || exit 1
-@@ -2745,12 +3246,99 @@ dragonegg|llvm)
+@@ -2745,12 +3261,99 @@ dragonegg|llvm)
  	v "llvm-link -o - $objs | opt $optflags | llc -o $tfn.s"
  	;;
  esac
@@ -2445,7 +2467,7 @@ see the Vcs-* tags in debian/control for
  test 0 = $eq && v $SIZE $tcfn
  i=install
  test -f /usr/ucb/$i && i=/usr/ucb/$i
-@@ -2760,7 +3348,7 @@ $e Installing the shell:
+@@ -2760,7 +3363,7 @@ $e Installing the shell:
  $e "# $i -c -s -o root -g bin -m 555 $tfn /bin/$tfn"
  if test $legacy = 0; then
  	$e "# grep -x /bin/$tfn /etc/shells >/dev/null || echo /bin/$tfn >>/etc/shells"
@@ -2454,7 +2476,7 @@ see the Vcs-* tags in debian/control for
  fi
  $e
  $e Installing the manual:
-@@ -2777,12 +3365,12 @@ if test -f mksh.cat1; then
+@@ -2777,12 +3380,12 @@ if test -f mksh.cat1; then
  	    "/usr/share/man/cat1/mksh.0"
  	$e or
  fi
@@ -2470,7 +2492,7 @@ see the Vcs-* tags in debian/control for
  exit 0
  
  : <<'EOD'
-@@ -2801,8 +3389,8 @@ LIBS				default empty; added after sourc
+@@ -2801,8 +3404,8 @@ LIBS				default empty; added after sourc
  				[Interix] default: -lcrypt (XXX still needed?)
  NOWARN				-Wno-error or similar
  NROFF				default: nroff
@@ -2481,7 +2503,7 @@ see the Vcs-* tags in debian/control for
  
  ==== feature selectors ====
  MKSH_UNLIMITED			1 to omit ulimit builtin completely
-@@ -2819,6 +3407,7 @@ KSH_VERSIONNAME_VENDOR_EXT	when patching
+@@ -2819,6 +3422,7 @@ KSH_VERSIONNAME_VENDOR_EXT	when patching
  MKSHRC_PATH			"~/.mkshrc" (do not change)
  MKSH_A4PB			force use of arc4random_pushb
  MKSH_ASSUME_UTF8		(0=disabled, 1=enabled; default: unset)
@@ -2489,7 +2511,7 @@ see the Vcs-* tags in debian/control for
  MKSH_BINSHPOSIX			if */sh or */-sh, enable set -o posix
  MKSH_BINSHREDUCED		if */sh or */-sh, enable set -o sh
  MKSH_CLS_STRING			KSH_ESC_STRING "[;H" KSH_ESC_STRING "[J"
-@@ -2841,7 +3430,6 @@ MKSH_SMALL			omit some code, optimise ha
+@@ -2841,7 +3445,6 @@ MKSH_SMALL			omit some code, optimise ha
  MKSH_SMALL_BUT_FAST		disable some hard-for-size optim. (modern sys.)
  MKSH_S_NOVI=1			disable Vi editing mode (default if MKSH_SMALL)
  MKSH_TYPEDEF_SIG_ATOMIC_T	define to e.g. 'int' if sig_atomic_t is missing
@@ -2497,7 +2519,7 @@ see the Vcs-* tags in debian/control for
  MKSH_UNEMPLOYED			disable job control (but not jobs/co-processes)
  USE_REALLOC_MALLOC		define as 0 to not use realloc as malloc
  
-@@ -2853,7 +3441,7 @@ them, set to a value other than 0 or 1.
+@@ -2853,7 +3456,7 @@ them, set to a value other than 0 or 1.
  MKSH_SMALL but with Vi mode, add -DMKSH_S_NOVI=0 to CPPFLAGS as well.
  
  Normally, the following command is what you want to run, then:
@@ -2736,7 +2758,7 @@ see the Vcs-* tags in debian/control for
 +++ mksh-59c/check.t
 @@ -1,9 +1,9 @@
 -# $MirOS: src/bin/mksh/check.t,v 1.853 2020/10/31 03:53:03 tg Exp $
-+# $MirOS: src/bin/mksh/check.t,v 1.917 2024/02/02 04:04:19 tg Exp $
++# $MirOS: src/bin/mksh/check.t,v 1.918 2024/07/26 18:39:05 tg Exp $
  # -*- mode: sh -*-
  #-
  # Copyright © 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
@@ -2751,7 +2773,7 @@ see the Vcs-* tags in debian/control for
  
  expected-stdout:
 -	KSH R59 2020/10/31
-+	KSH R59 2024/02/01
++	KSH R59 2024/07/26
  description:
  	Check base version of full shell
  stdin:
@@ -8572,7 +8594,7 @@ see the Vcs-* tags in debian/control for
  #include "sh.h"
  
 -__RCSID("$MirOS: src/bin/mksh/eval.c,v 1.231 2020/05/05 21:34:27 tg Exp $");
-+__RCSID("$MirOS: src/bin/mksh/eval.c,v 1.261 2023/09/16 23:07:44 tg Exp $");
++__RCSID("$MirOS: src/bin/mksh/eval.c,v 1.262 2024/07/05 13:57:39 tg Exp $");
  
  /*
   * string expansion
@@ -8585,16 +8607,8 @@ see the Vcs-* tags in debian/control for
  } Expand;
  
  #define XBASE		0	/* scanning original string */
-@@ -76,20 +76,28 @@ typedef struct {
- #define STYPE_SINGLE	0x2FF
- #define STYPE_MASK	0x300
- 
--static int varsub(Expand *, const char *, const char *, unsigned int *, int *);
-+static int varsub(Expand *, const char *, const char *, unsigned int *, int *)
-+#if defined(__GNUC__) && (__GNUC__ >= 13)
-+    __attribute__((__noinline__))
-+#endif
-+    ;
+@@ -79,17 +79,21 @@ typedef struct {
+ static int varsub(Expand *, const char *, const char *, unsigned int *, int *);
  static int comsub(Expand *, const char *, int);
  static char *valsub(struct op *, Area *);
 +static void funsub(struct op *);
@@ -8618,7 +8632,7 @@ see the Vcs-* tags in debian/control for
  /* UTFMODE functions */
  static int
  utflen(const char *s)
-@@ -99,7 +107,7 @@ utflen(const char *s)
+@@ -99,7 +103,7 @@ utflen(const char *s)
  	if (UTFMODE) {
  		n = 0;
  		while (*s) {
@@ -8627,7 +8641,7 @@ see the Vcs-* tags in debian/control for
  			++n;
  		}
  	} else
-@@ -116,7 +124,7 @@ utfincptr(const char *s, mksh_ari_t *lp)
+@@ -116,7 +120,7 @@ utfincptr(const char *s, mksh_ari_t *lp)
  	const char *cp = s;
  
  	while ((*lp)--)
@@ -8636,7 +8650,7 @@ see the Vcs-* tags in debian/control for
  	*lp = cp - s;
  }
  
-@@ -131,7 +139,8 @@ substitute(const char *cp, int f)
+@@ -131,7 +135,8 @@ substitute(const char *cp, int f)
  	s->start = s->str = cp;
  	source = s;
  	if (yylex(ONEWORD) != LWORD)
@@ -8646,7 +8660,7 @@ see the Vcs-* tags in debian/control for
  	source = sold;
  	afree(s, ATEMP);
  	return (evalstr(yylval.cp, f));
-@@ -212,8 +221,8 @@ typedef struct SubType {
+@@ -212,8 +217,8 @@ typedef struct SubType {
  	size_t	base;		/* start position of expanded word */
  	unsigned short stype;	/* [=+-?%#] action after expanded word */
  	short	f;		/* saved value of f (DOPAT, etc) */
@@ -8657,7 +8671,7 @@ see the Vcs-* tags in debian/control for
  } SubType;
  
  void
-@@ -248,15 +257,16 @@ expand(
+@@ -248,15 +253,16 @@ expand(
  	SubType st_head, *st;
  	/* record number of trailing newlines in COMSUB */
  	int newlines = 0;
@@ -8677,7 +8691,7 @@ see the Vcs-* tags in debian/control for
  		f &= ~(DOVACHECK | DOBLANK | DOGLOB | DOTILDE);
  		f |= DOASNTILDE | DOSCALAR;
  	}
-@@ -272,11 +282,11 @@ expand(
+@@ -272,11 +278,11 @@ expand(
  	type = XBASE;
  	sp = ccp;
  	fdo = 0;
@@ -8691,7 +8705,7 @@ see the Vcs-* tags in debian/control for
  	word = (f&DOBLANK) ? IFS_WS : IFS_WORD;
  	/* clang doesn't know OSUBST comes before CSUBST */
  	memset(&st_head, 0, sizeof(st_head));
-@@ -361,16 +371,17 @@ expand(
+@@ -361,16 +367,17 @@ expand(
  					}
  					*dp++ = ')'; *dp++ = ')';
  				} else {
@@ -8716,7 +8730,7 @@ see the Vcs-* tags in debian/control for
  					type = XSUB;
  					if (f & DOBLANK)
  						doblank++;
-@@ -386,11 +397,11 @@ expand(
+@@ -386,11 +393,11 @@ expand(
  			 */
  				/* skip the { or x (}) */
  				const char *varname = ++sp;
@@ -8730,7 +8744,7 @@ see the Vcs-* tags in debian/control for
  				type = varsub(&x, varname, sp, &stype, &slen);
  				if (type < 0) {
  					char *beg, *end, *str;
-@@ -398,14 +409,16 @@ expand(
+@@ -398,14 +405,16 @@ expand(
  					/* restore sp */
  					sp = varname - 2;
  					beg = wdcopy(sp, ATEMP);
@@ -8750,7 +8764,7 @@ see the Vcs-* tags in debian/control for
  				}
  				if (f & DOBLANK)
  					doblank++;
-@@ -443,6 +456,7 @@ expand(
+@@ -443,6 +452,7 @@ expand(
  					switch (stype & STYPE_SINGLE) {
  					case ORD('#') | STYPE_AT:
  					case ORD('Q') | STYPE_AT:
@@ -8758,7 +8772,7 @@ see the Vcs-* tags in debian/control for
  						break;
  					case ORD('0'): {
  						char *beg, *mid, *end, *stg;
-@@ -465,11 +479,11 @@ expand(
+@@ -465,11 +475,11 @@ expand(
  							sp += end - beg - 1;
  						}
  						evaluate(substitute(stg = wdstrip(beg, 0), 0),
@@ -8772,7 +8786,7 @@ see the Vcs-* tags in debian/control for
  							afree(stg, ATEMP);
  						}
  						afree(beg, ATEMP);
-@@ -541,7 +555,7 @@ expand(
+@@ -541,7 +551,7 @@ expand(
  							goto no_repl;
  						}
  						if ((stype & STYPE_MASK) &&
@@ -8781,7 +8795,7 @@ see the Vcs-* tags in debian/control for
  							/*
  							 * pattern matches empty
  							 * string => don't loop
-@@ -568,13 +582,13 @@ expand(
+@@ -568,13 +578,13 @@ expand(
  						 * this would not be necessary if gmatchx would return
  						 * the start and end values of a match found, like re*
  						 */
@@ -8797,7 +8811,7 @@ see the Vcs-* tags in debian/control for
  									break;
  								else
  									sbeg++;
-@@ -583,11 +597,11 @@ expand(
+@@ -583,11 +593,11 @@ expand(
  						p = d;
  						if (ord(fpat) != ORD('%'))
  							while (p >= sbeg) {
@@ -8811,7 +8825,7 @@ see the Vcs-* tags in debian/control for
  								*p = c;
  								if (gotmatch)
  									break;
-@@ -703,8 +717,10 @@ expand(
+@@ -703,8 +713,10 @@ expand(
  						break;
  					case ORD('?'):
  						if (*sp == CSUBST)
@@ -8824,7 +8838,7 @@ see the Vcs-* tags in debian/control for
  						f &= ~DOBLANK;
  						f |= DOTEMP;
  						/* FALLTHROUGH */
-@@ -785,9 +801,9 @@ expand(
+@@ -785,9 +797,9 @@ expand(
  					 * in AT&T ksh.
  					 */
  					/*
@@ -8836,7 +8850,7 @@ see the Vcs-* tags in debian/control for
  					 */
  					len = strlen(dp) + 1;
  					setstr(st->var,
-@@ -803,11 +819,13 @@ expand(
+@@ -803,11 +815,13 @@ expand(
  				case ORD('?'):
  					dp = Xrestpos(ds, dp, st->base);
  
@@ -8852,7 +8866,7 @@ see the Vcs-* tags in debian/control for
  					    (unsigned int)hash(str_val(st->var)));
  					goto common_CSUBST;
  				case ORD('Q') | STYPE_AT: {
-@@ -818,6 +836,14 @@ expand(
+@@ -818,6 +832,14 @@ expand(
  					x.str = shf_sclose(&shf);
  					goto common_CSUBST;
  				    }
@@ -8867,7 +8881,7 @@ see the Vcs-* tags in debian/control for
  				case ORD('0'):
  				case ORD('/') | STYPE_AT:
  				case ORD('/'):
-@@ -838,19 +864,19 @@ expand(
+@@ -838,19 +860,19 @@ expand(
  			case OPAT:
  				/* open pattern: *(foo|bar) */
  				/* Next char is the type of pattern */
@@ -8890,7 +8904,7 @@ see the Vcs-* tags in debian/control for
  				c = ORD(/*(*/ ')');
  				break;
  			}
-@@ -893,7 +919,7 @@ expand(
+@@ -893,7 +915,7 @@ expand(
  				if (ord(*x.str) == ORD('('/*)*/)) {
  					++x.str;
  					c |= 0x80U;
@@ -8899,7 +8913,7 @@ see the Vcs-* tags in debian/control for
  				}
  				break;
  			case ORD('('):
-@@ -901,7 +927,7 @@ expand(
+@@ -901,7 +923,7 @@ expand(
  				/* FALLTHROUGH */
  			case ORD('|'):
  			case ORD(')'):
@@ -8908,7 +8922,7 @@ see the Vcs-* tags in debian/control for
  				break;
  			}
  			break;
-@@ -1005,8 +1031,8 @@ expand(
+@@ -1005,8 +1027,8 @@ expand(
  				c = ORD('\n');
  				--newlines;
  			} else {
@@ -8919,7 +8933,7 @@ see the Vcs-* tags in debian/control for
  #ifdef MKSH_WITH_TEXTMODE
  					if (c == ORD('\r')) {
  						c = shf_getc(x.u.shf);
-@@ -1063,25 +1089,26 @@ expand(
+@@ -1063,25 +1085,26 @@ expand(
  			if ((word == IFS_WORD) || (word == IFS_QUOTE) || (c &&
  			    (word == IFS_IWS || word == IFS_NWS) &&
  			    !ctype(c, C_IFSWS))) {
@@ -8951,7 +8965,7 @@ see the Vcs-* tags in debian/control for
  				/* must be 1/0 */
  				tilde_ok = (f & (DOTILDE | DOASNTILDE)) ? 1 : 0;
  				if (c == 0)
-@@ -1143,7 +1170,7 @@ expand(
+@@ -1143,7 +1166,7 @@ expand(
  					/* Note first unquoted = for ~ */
  					if (!(f & DOTEMP) && (!Flag(FPOSIX) ||
  					    (f & DOASNTILDE)) && !saw_eq) {
@@ -8960,7 +8974,7 @@ see the Vcs-* tags in debian/control for
  						tilde_ok = 1;
  					}
  					break;
-@@ -1168,7 +1195,7 @@ expand(
+@@ -1168,7 +1191,7 @@ expand(
  
  						tcp = maybe_expand_tilde(sp,
  						    &ds, &tdp,
@@ -8969,7 +8983,7 @@ see the Vcs-* tags in debian/control for
  						if (tcp) {
  							if (dp != tdp)
  								word = IFS_WORD;
-@@ -1184,7 +1211,7 @@ expand(
+@@ -1184,7 +1207,7 @@ expand(
  				quote &= ~2;
  
  			if (make_magic) {
@@ -8978,7 +8992,7 @@ see the Vcs-* tags in debian/control for
  				fdo |= DOMAGIC | (f & DOGLOB);
  				*dp++ = MAGIC;
  			} else if (ISMAGIC(c)) {
-@@ -1198,15 +1225,15 @@ expand(
+@@ -1198,15 +1221,15 @@ expand(
  	}
  }
  
@@ -8997,7 +9011,7 @@ see the Vcs-* tags in debian/control for
  }
  
  /*
-@@ -1225,7 +1252,7 @@ varsub(Expand *xp, const char *sp, const
+@@ -1225,7 +1248,7 @@ varsub(Expand *xp, const char *sp, const
  	int slen = 0;
  	const char *p;
  	struct tbl *vp;
@@ -9006,7 +9020,7 @@ see the Vcs-* tags in debian/control for
  	int sc;
  	XPtrV wv;
  
-@@ -1300,7 +1327,7 @@ varsub(Expand *xp, const char *sp, const
+@@ -1300,7 +1323,7 @@ varsub(Expand *xp, const char *sp, const
  			if (sc & 2) {
  				stype = 0;
  				XPinit(wv, 32);
@@ -9015,7 +9029,7 @@ see the Vcs-* tags in debian/control for
  				do {
  					if (vp->flag & ISSET)
  						XPput(wv, shf_smprintf(Tf_lu,
-@@ -1310,12 +1337,13 @@ varsub(Expand *xp, const char *sp, const
+@@ -1310,12 +1333,13 @@ varsub(Expand *xp, const char *sp, const
  			}
  			xp->var = global(sp);
  			/* use saved p from above */
@@ -9031,7 +9045,7 @@ see the Vcs-* tags in debian/control for
  			/* NOTREACHED */
  #endif
  		case ORD('%'):
-@@ -1327,13 +1355,7 @@ varsub(Expand *xp, const char *sp, const
+@@ -1327,13 +1351,7 @@ varsub(Expand *xp, const char *sp, const
  			/* partial utf_mbswidth reimplementation */
  			sc = 0;
  			while (*p) {
@@ -9046,7 +9060,7 @@ see the Vcs-* tags in debian/control for
  				/* c == char or wchar at p++ */
  				if ((slen = utf_wcwidth(c)) == -1) {
  					/* 646, 8859-1, 10646 C0/C1 */
-@@ -1347,9 +1369,9 @@ varsub(Expand *xp, const char *sp, const
+@@ -1347,9 +1365,9 @@ varsub(Expand *xp, const char *sp, const
  		case ORD('#'):
  			  switch (sc & 3) {
  			case 3:
@@ -9058,7 +9072,7 @@ see the Vcs-* tags in debian/control for
  				sc = 0;
  				do {
  					if (vp->flag & ISSET)
-@@ -1367,7 +1389,9 @@ varsub(Expand *xp, const char *sp, const
+@@ -1367,7 +1385,9 @@ varsub(Expand *xp, const char *sp, const
  			}
  			/* ${%var} also here */
  			if (Flag(FNOUNSET) && sc == 0 && !zero_ok)
@@ -9069,7 +9083,7 @@ see the Vcs-* tags in debian/control for
  			xp->str = shf_smprintf(Tf_d, sc);
  			break;
  		}
-@@ -1414,6 +1438,7 @@ varsub(Expand *xp, const char *sp, const
+@@ -1414,6 +1434,7 @@ varsub(Expand *xp, const char *sp, const
  		case ORD('#'):
  		case ORD('/'):
  		case ORD('Q'):
@@ -9077,7 +9091,7 @@ see the Vcs-* tags in debian/control for
  			break;
  		default:
  			return (-1);
-@@ -1452,13 +1477,14 @@ varsub(Expand *xp, const char *sp, const
+@@ -1452,13 +1473,14 @@ varsub(Expand *xp, const char *sp, const
  		case ORD('0'):
  		case ORD('#') | STYPE_AT:
  		case ORD('Q') | STYPE_AT:
@@ -9093,7 +9107,7 @@ see the Vcs-* tags in debian/control for
  			do {
  				if (vp->flag & ISSET)
  					XPput(wv, str_val(vp));
-@@ -1476,7 +1502,7 @@ varsub(Expand *xp, const char *sp, const
+@@ -1476,7 +1498,7 @@ varsub(Expand *xp, const char *sp, const
  			else
  				xp->u.strv = (const char **)e->loc->argv + 1;
  			/* POSIX 2009? */
@@ -9102,7 +9116,7 @@ see the Vcs-* tags in debian/control for
  		}
  		/* have we got any elements? */
  		if (c) {
-@@ -1487,7 +1513,7 @@ varsub(Expand *xp, const char *sp, const
+@@ -1487,7 +1509,7 @@ varsub(Expand *xp, const char *sp, const
  			/* yes → load first */
  			xp->str = *xp->u.strv++;
  			/* $@ or ${foo[@]} */
@@ -9111,7 +9125,7 @@ see the Vcs-* tags in debian/control for
  			state = XARG;
  		}
  	}
-@@ -1502,12 +1528,14 @@ varsub(Expand *xp, const char *sp, const
+@@ -1502,12 +1524,14 @@ varsub(Expand *xp, const char *sp, const
  	    stype == (ORD('0') | STYPE_DBL) ||
  	    stype == (ORD('#') | STYPE_AT) ||
  	    stype == (ORD('Q') | STYPE_AT) ||
@@ -9127,7 +9141,7 @@ see the Vcs-* tags in debian/control for
  	*stypep = stype;
  	*slenp = slen;
  	return (state);
-@@ -1522,8 +1550,8 @@ comsub(Expand *xp, const char *cp, int f
+@@ -1522,8 +1546,8 @@ comsub(Expand *xp, const char *cp, int f
  	Source *s, *sold;
  	struct op *t;
  	struct shf *shf;
@@ -9138,7 +9152,7 @@ see the Vcs-* tags in debian/control for
  
  	switch (fn) {
  	case COMASUB:
-@@ -1532,13 +1560,13 @@ comsub(Expand *xp, const char *cp, int f
+@@ -1532,13 +1556,13 @@ comsub(Expand *xp, const char *cp, int f
  			/* FALLTHROUGH */
  	case FUNASUB:
  		  fn = FUNSUB;
@@ -9154,7 +9168,7 @@ see the Vcs-* tags in debian/control for
  	afree(s, ATEMP);
  	source = sold;
  
-@@ -1548,7 +1576,7 @@ comsub(Expand *xp, const char *cp, int f
+@@ -1548,7 +1572,7 @@ comsub(Expand *xp, const char *cp, int f
  		return (XBASE);
  
  	/* no waitlast() unless specifically enabled later */
@@ -9163,7 +9177,7 @@ see the Vcs-* tags in debian/control for
  
  	if (t->type == TCOM &&
  	    *t->args == NULL && *t->vars == NULL && t->ioact != NULL) {
-@@ -1561,9 +1589,9 @@ comsub(Expand *xp, const char *cp, int f
+@@ -1561,9 +1585,9 @@ comsub(Expand *xp, const char *cp, int f
  			shf = shf_open(name = evalstr(io->ioname, DOTILDE),
  				O_RDONLY, 0, SHF_MAPHI | SHF_CLEXEC);
  			if (shf == NULL)
@@ -9176,7 +9190,7 @@ see the Vcs-* tags in debian/control for
  			break;
  		case IOHERE:
  			if (!herein(io, &name)) {
-@@ -1578,7 +1606,8 @@ comsub(Expand *xp, const char *cp, int f
+@@ -1578,7 +1602,8 @@ comsub(Expand *xp, const char *cp, int f
  			shf = NULL;
  			break;
  		default:
@@ -9186,7 +9200,7 @@ see the Vcs-* tags in debian/control for
  			    snptreef(NULL, 32, Tft_R, io));
  		}
  	} else if (fn == FUNSUB) {
-@@ -1590,22 +1619,21 @@ comsub(Expand *xp, const char *cp, int f
+@@ -1590,22 +1615,21 @@ comsub(Expand *xp, const char *cp, int f
  		 * with an shf open for reading (buffered) but yet unused
  		 */
  		maketemp(ATEMP, TT_FUNSUB, &tf);
@@ -9214,7 +9228,7 @@ see the Vcs-* tags in debian/control for
  		subst_exstat = exstat & 0xFF;
  		/* rewind the tempfile and restore regular stdout */
  		lseek(shf_fileno(shf), (off_t)0, SEEK_SET);
-@@ -1621,14 +1649,14 @@ comsub(Expand *xp, const char *cp, int f
+@@ -1621,14 +1645,14 @@ comsub(Expand *xp, const char *cp, int f
  		shf = shf_fdopen(pv[0], SHF_RD, NULL);
  		ofd1 = savefd(1);
  		if (pv[1] != 1) {
@@ -9231,7 +9245,7 @@ see the Vcs-* tags in debian/control for
  	}
  
  	xp->u.shf = shf;
-@@ -1647,48 +1675,47 @@ trimsub(char *str, char *pat, int how)
+@@ -1647,48 +1671,47 @@ trimsub(char *str, char *pat, int how)
  	switch (how & (STYPE_CHAR | STYPE_DBL)) {
  	case ORD('#'):
  		/* shortest match at beginning */
@@ -9296,7 +9310,7 @@ see the Vcs-* tags in debian/control for
   trimsub_match:
  				record_match(p);
  				strndupx(end, str, p - str, ATEMP);
-@@ -1708,7 +1735,7 @@ trimsub(char *str, char *pat, int how)
+@@ -1708,7 +1731,7 @@ trimsub(char *str, char *pat, int how)
  
  /* XXX cp not const 'cause slashes are temporarily replaced with NULs... */
  static void
@@ -9305,7 +9319,7 @@ see the Vcs-* tags in debian/control for
  {
  	int oldsize = XPsize(*wp);
  
-@@ -1729,7 +1756,7 @@ glob(char *cp, XPtrV *wp, bool markdirs)
+@@ -1729,7 +1752,7 @@ glob(char *cp, XPtrV *wp, bool markdirs)
   * the number of matches found.
   */
  int
@@ -9314,7 +9328,7 @@ see the Vcs-* tags in debian/control for
  {
  	int oldsize = XPsize(*wp);
  	XString xs;
-@@ -1753,6 +1780,8 @@ globit(XString *xs,	/* dest string */
+@@ -1753,6 +1776,8 @@ globit(XString *xs,	/* dest string */
  	char *xp = *xpp;
  	char *se;
  	char odirsep;
@@ -9323,7 +9337,7 @@ see the Vcs-* tags in debian/control for
  
  	/* This to allow long expansions to be interrupted */
  	intrcheck();
-@@ -1811,6 +1840,7 @@ globit(XString *xs,	/* dest string */
+@@ -1811,6 +1836,7 @@ globit(XString *xs,	/* dest string */
  		Xcheck(*xs, xp);
  		*xp++ = *sp++;
  	}
@@ -9331,7 +9345,7 @@ see the Vcs-* tags in debian/control for
  	np = mksh_sdirsep(sp);
  	if (np != NULL) {
  		se = np;
-@@ -1822,7 +1852,6 @@ globit(XString *xs,	/* dest string */
+@@ -1822,7 +1848,6 @@ globit(XString *xs,	/* dest string */
  		se = strnul(sp);
  	}
  
@@ -9339,7 +9353,7 @@ see the Vcs-* tags in debian/control for
  	/*
  	 * Check if sp needs globbing - done to avoid pattern checks for strings
  	 * containing MAGIC characters, open [s without the matching close ],
-@@ -1836,43 +1865,34 @@ globit(XString *xs,	/* dest string */
+@@ -1836,43 +1861,34 @@ globit(XString *xs,	/* dest string */
  		xp = strnul(xp);
  		*xpp = xp;
  		globit(xs, xpp, np, wp, check);
@@ -9393,7 +9407,7 @@ see the Vcs-* tags in debian/control for
  }
  
  /* remove MAGIC from string */
-@@ -1909,7 +1929,7 @@ debunk(char *dp, const char *sp, size_t
+@@ -1909,7 +1925,7 @@ debunk(char *dp, const char *sp, size_t
   * past the name, otherwise returns 0.
   */
  static const char *
@@ -9402,7 +9416,7 @@ see the Vcs-* tags in debian/control for
  {
  	XString ts;
  	char *dp = *dpp;
-@@ -1951,7 +1971,7 @@ do_tilde(char *cp)
+@@ -1951,7 +1967,7 @@ do_tilde(char *cp)
  {
  	char *dp = null;
  #ifndef MKSH_NOPWNAM
@@ -9411,7 +9425,7 @@ see the Vcs-* tags in debian/control for
  #endif
  
  	if (cp[0] == '\0')
-@@ -1963,7 +1983,7 @@ do_tilde(char *cp)
+@@ -1963,7 +1979,7 @@ do_tilde(char *cp)
  #ifndef MKSH_NOPWNAM
  	else {
  		dp = homedir(cp);
@@ -9420,7 +9434,7 @@ see the Vcs-* tags in debian/control for
  	}
  #endif
  
-@@ -2017,7 +2037,7 @@ alt_expand(XPtrV *wp, char *start, char
+@@ -2017,7 +2033,7 @@ alt_expand(XPtrV *wp, char *start, char
  	char *p = exp_start;
  
  	/* search for open brace */
@@ -9429,7 +9443,7 @@ see the Vcs-* tags in debian/control for
  		p += 2;
  	brace_start = p;
  
-@@ -2046,7 +2066,7 @@ alt_expand(XPtrV *wp, char *start, char
+@@ -2046,7 +2062,7 @@ alt_expand(XPtrV *wp, char *start, char
  		 * expansion. }
  		 */
  		if (fdo & DOGLOB)
@@ -9438,7 +9452,7 @@ see the Vcs-* tags in debian/control for
  		else
  			XPput(*wp, debunk(start, start, end - start));
  		return;
-@@ -2067,7 +2087,7 @@ alt_expand(XPtrV *wp, char *start, char
+@@ -2067,7 +2083,7 @@ alt_expand(XPtrV *wp, char *start, char
  			else if ((ord(*p) == ORD(/*{*/ '}') && --count == 0) ||
  			    (*p == ',' && count == 1)) {
  				char *news;
@@ -9447,7 +9461,7 @@ see the Vcs-* tags in debian/control for
  
  				/*
  				 * addition safe since these operate on
-@@ -2090,22 +2110,55 @@ alt_expand(XPtrV *wp, char *start, char
+@@ -2090,22 +2106,55 @@ alt_expand(XPtrV *wp, char *start, char
  	return;
  }
  
@@ -9518,7 +9532,7 @@ see the Vcs-* tags in debian/control for
   * Copyright (c) 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
   *		 2011, 2012, 2013, 2014, 2015, 2016, 2017, 2018,
 - *		 2019, 2020
-+ *		 2019, 2020, 2021, 2022, 2023
++ *		 2019, 2020, 2021, 2022, 2023, 2024
   *	mirabilos <m@mirbsd.org>
   *
   * Provided that these terms and disclaimer and all copyright notices
@@ -9527,7 +9541,7 @@ see the Vcs-* tags in debian/control for
  #include "sh.h"
  
 -__RCSID("$MirOS: src/bin/mksh/exec.c,v 1.224 2020/08/27 19:52:43 tg Exp $");
-+__RCSID("$MirOS: src/bin/mksh/exec.c,v 1.247 2023/09/16 23:07:45 tg Exp $");
++__RCSID("$MirOS: src/bin/mksh/exec.c,v 1.248 2024/07/25 00:29:04 tg Exp $");
  
  #ifndef MKSH_DEFAULT_EXECSHELL
  #define MKSH_DEFAULT_EXECSHELL	MKSH_UNIXROOT "/bin/sh"
@@ -9997,8 +10011,13 @@ see the Vcs-* tags in debian/control for
  		}
  
  		rv = exchild(&texec, flags, xerrok, -1);
-@@ -891,9 +919,6 @@ scriptexec(struct op *tp, const char **a
- #endif
+@@ -886,14 +914,9 @@ scriptexec(struct op *tp, const char **a
+ #ifndef MKSH_SMALL
+ 	if ((fd = binopen2(tp->str, O_RDONLY | O_MAYEXEC)) >= 0) {
+ 		unsigned char *cp;
+-#ifndef MKSH_EBCDIC
+ 		unsigned short m;
+-#endif
  		ssize_t n;
  
 -#if defined(__OS2__) && defined(MKSH_WITH_TEXTMODE)
@@ -10007,7 +10026,7 @@ see the Vcs-* tags in debian/control for
  		/* read first couple of octets from file */
  		n = read(fd, buf, sizeof(buf) - 1);
  		close(fd);
-@@ -903,11 +928,8 @@ scriptexec(struct op *tp, const char **a
+@@ -903,31 +926,30 @@ scriptexec(struct op *tp, const char **a
  		/* terminate buffer */
  		buf[n] = '\0';
  
@@ -10015,51 +10034,96 @@ see the Vcs-* tags in debian/control for
 -		cp = buf + (n = ((buf[0] == 0xEF) && (buf[1] == 0xBB) &&
 -		    (buf[2] == 0xBF)) ? 3 : 0);
 -
++		/* scan for shebang magic */
++		if (ord(buf[0]) == ORD('#') && ord(buf[1]) == ORD('!'))
++			n = 2;
++#ifdef __OS2__
++		else if (n > 8 && !strncmp(buf, Textproc, 7) &&
++		    ctype(buf[7], C_BLANK))
++			n = 8;
++#endif
++		else
++			goto noshebang;
  		/* scan for newline or NUL (end of buffer) */
-+		cp = buf;
++		cp = buf + n;
  		while (!ctype(*cp, C_NL | C_NUL))
  			++cp;
  		/* if the shebang line is longer than MAXINTERP, bail out */
-@@ -916,8 +938,8 @@ scriptexec(struct op *tp, const char **a
+ 		if (!*cp)
+-			goto noshebang;
++			kerrf0(KWF_ERR(126) | KWF_PREFIX | KWF_FILELINE |
++			    KWF_NOERRNO, "%s: not executable: shebang too long",
++			    tp->str);
  		/* replace newline by NUL */
  		*cp = '\0';
  
 -		/* restore start of shebang position (buf+0 or buf+3) */
--		cp = buf + n;
 +		/* restore start of shebang position */
-+		cp = buf;
- 		/* bail out if no shebang magic found */
- 		if (cp[0] == '#' && cp[1] == '!')
- 			cp += 2;
-@@ -969,8 +991,9 @@ scriptexec(struct op *tp, const char **a
- #ifndef MKSH_EBCDIC
- 		m = buf[0] << 8 | buf[1];
- 		if (m == 0x7F45 && buf[2] == 'L' && buf[3] == 'F')
+ 		cp = buf + n;
+-		/* bail out if no shebang magic found */
+-		if (cp[0] == '#' && cp[1] == '!')
+-			cp += 2;
+-#ifdef __OS2__
+-		else if (!strncmp(cp, Textproc, 7) &&
+-		    ctype(cp[7], C_BLANK))
+-			cp += 8;
+-#endif
+-		else
+-			goto noshebang;
+ 		/* skip whitespace before shell name */
+ 		while (ctype(*cp, C_BLANK))
+ 			++cp;
+@@ -966,11 +988,12 @@ scriptexec(struct op *tp, const char **a
+ #endif
+ 		goto nomagic;
+  noshebang:
+-#ifndef MKSH_EBCDIC
+-		m = buf[0] << 8 | buf[1];
+-		if (m == 0x7F45 && buf[2] == 'L' && buf[3] == 'F')
 -			errorf("%s: not executable: %d-bit ELF file", tp->str,
 -			    32 * buf[4]);
-+			kerrf0(KWF_ERR(1) | KWF_PREFIX | KWF_FILELINE |
-+			    KWF_NOERRNO, "%s: not executable: %d-bit ELF file",
-+			    tp->str, 32 * buf[4]);
++		m = ord(rtt2asc(buf[0])) << 8 | ord(rtt2asc(buf[1]));
++		if (m == 0x7F45 && ord(buf[2]) == ORD('L') &&
++		    ord(buf[3]) == ORD('F'))
++			kerrf0(KWF_ERR(126) | KWF_PREFIX | KWF_FILELINE |
++			    KWF_NOERRNO, "%s: not executable: %u-bit ELF file",
++			    tp->str, 32U * buf[4]);
  		if ((m == /* OMAGIC */ 0407) ||
  		    (m == /* NMAGIC */ 0410) ||
  		    (m == /* ZMAGIC */ 0413) ||
-@@ -983,8 +1006,13 @@ scriptexec(struct op *tp, const char **a
+@@ -978,14 +1001,25 @@ scriptexec(struct op *tp, const char **a
+ 		    (m == /* ECOFF_I386 */ 0x4C01) ||
+ 		    (m == /* ECOFF_M68K */ 0x0150 || m == 0x5001) ||
+ 		    (m == /* ECOFF_SH */   0x0500 || m == 0x0005) ||
+-		    (m == /* bzip */ 0x425A) || (m == /* "MZ" */ 0x4D5A) ||
++		    (m == /* "MZ" */ 0x4D5A && !( /* cosmo libc APE */
++		     ord(buf[2]) == ORD('q') && ord(buf[3]) == ORD('F') &&
++		     ord(buf[4]) == ORD('p') && ord(buf[5]) == ORD('D') &&
++		     ord(buf[6]) == ORD('=') && ord(buf[7]) == ORD('\''))) ||
+ 		    (m == /* "NE" */ 0x4E45) || (m == /* "LX" */ 0x4C58) ||
  		    (m == /* ksh93 */ 0x0B13) || (m == /* LZIP */ 0x4C5A) ||
- 		    (m == /* xz */ 0xFD37 && buf[2] == 'z' && buf[3] == 'X' &&
- 		    buf[4] == 'Z') || (m == /* 7zip */ 0x377A) ||
+-		    (m == /* xz */ 0xFD37 && buf[2] == 'z' && buf[3] == 'X' &&
+-		    buf[4] == 'Z') || (m == /* 7zip */ 0x377A) ||
 -		    (m == /* gzip */ 0x1F8B) || (m == /* .Z */ 0x1F9D))
 -			errorf("%s: not executable: magic %04X", tp->str, m);
+-#endif
++		    (m == /* xz */ 0xFD37 && ord(buf[2]) == ORD('z') &&
++		     ord(buf[3]) == ORD('X') && ord(buf[4]) == ORD('Z')) ||
++		    (m == /* Zstd */ 0x28B5 && ord(rtt2asc(buf[2])) == 0x2FU &&
++		     ord(rtt2asc(buf[3])) == 0xFDU) ||
++		    (m == /* bzip */ 0x425A) || (m == /* 7zip */ 0x377A) ||
 +		    (m == /* gzip */ 0x1F8B) || (m == /* .Z */ 0x1F9D) ||
-+		    (m == /* UTF-8 BOM */ 0xEFBB && buf[2] == 0xBF) ||
++		    (m == /* UTF-8 BOM */ 0xEFBB &&
++		     ord(rtt2asc(buf[2])) == 0xBFU) ||
 +		    (m == /* UCS-4, may also be general binary */ 0x0000) ||
 +		    (m == /* UCS-2LE */ 0xFFFE) || (m == /* UCS-2BE */ 0xFEFF))
 +			kerrf0(KWF_ERR(126) | KWF_PREFIX | KWF_FILELINE |
 +			    KWF_NOERRNO, "%s: not executable: magic %04X",
 +			    tp->str, m);
- #endif
  #ifdef __OS2__
  		cp = _getext(tp->str);
-@@ -1010,14 +1038,14 @@ scriptexec(struct op *tp, const char **a
+ 		if (cp && (!stricmp(cp, ".cmd") || !stricmp(cp, ".bat"))) {
+@@ -1010,14 +1044,14 @@ scriptexec(struct op *tp, const char **a
  	execve(args.rw[0], args.rw, cap.rw);
  
  	/* report both the program that was run and the bogus interpreter */
@@ -10076,7 +10140,7 @@ see the Vcs-* tags in debian/control for
  }
  
  struct tbl *
-@@ -1031,7 +1059,7 @@ get_builtin(const char *s)
+@@ -1031,7 +1065,7 @@ get_builtin(const char *s)
   * is created if none is found.
   */
  struct tbl *
@@ -10085,7 +10149,7 @@ see the Vcs-* tags in debian/control for
  {
  	struct block *l;
  	struct tbl *tp = NULL;
-@@ -1058,17 +1086,17 @@ findfunc(const char *name, uint32_t h, b
+@@ -1058,17 +1092,17 @@ findfunc(const char *name, uint32_t h, b
  int
  define(const char *name, struct op *t)
  {
@@ -10107,7 +10171,7 @@ see the Vcs-* tags in debian/control for
  		/*
  		 * If this function is currently being executed, we zap
  		 * this table entry so findfunc() won't see it
-@@ -1108,7 +1136,7 @@ const char *
+@@ -1108,7 +1142,7 @@ const char *
  builtin(const char *name, int (*func) (const char **))
  {
  	struct tbl *tp;
@@ -10116,7 +10180,7 @@ see the Vcs-* tags in debian/control for
  
  	/* see if any flags should be set for this builtin */
   flags_loop:
-@@ -1165,8 +1193,8 @@ builtin(const char *name, int (*func) (c
+@@ -1165,8 +1199,8 @@ builtin(const char *name, int (*func) (c
  struct tbl *
  findcom(const char *name, int flags)
  {
@@ -10127,7 +10191,7 @@ see the Vcs-* tags in debian/control for
  	struct tbl *tp = NULL, *tbi;
  	/* insert if not found */
  	unsigned char insert = Flag(FTRACKALL);
-@@ -1188,7 +1216,7 @@ findcom(const char *name, int flags)
+@@ -1188,7 +1222,7 @@ findcom(const char *name, int flags)
  	if ((flags & FC_SPECBI) && tbi && (tbi->flag & SPEC_BI))
  		tp = tbi;
  	if (!tp && (flags & FC_FUNC)) {
@@ -10136,7 +10200,7 @@ see the Vcs-* tags in debian/control for
  		if (tp && !(tp->flag & ISSET)) {
  			if ((fpath = str_val(global(TFPATH))) == null) {
  				tp->u.fpath = NULL;
-@@ -1220,7 +1248,7 @@ findcom(const char *name, int flags)
+@@ -1220,7 +1254,7 @@ findcom(const char *name, int flags)
  				tp = ktenter(&taliases, name, h);
  				tp->type = CTALIAS;
  			} else {
@@ -10145,7 +10209,7 @@ see the Vcs-* tags in debian/control for
  				tp->type = CEXEC;
  			}
  			/* make ~ISSET */
-@@ -1244,7 +1272,7 @@ findcom(const char *name, int flags)
+@@ -1244,7 +1278,7 @@ findcom(const char *name, int flags)
  			 * even if the command hasn't been set up as an
  			 * autoloaded function (ie, no typeset -uf).
  			 */
@@ -10154,7 +10218,7 @@ see the Vcs-* tags in debian/control for
  			tp->type = CFUNC;
  			/* make ~ISSET */
  			tp->flag = DEFINED;
-@@ -1259,7 +1287,7 @@ findcom(const char *name, int flags)
+@@ -1259,7 +1293,7 @@ findcom(const char *name, int flags)
   * (just relative or all?)
   */
  void
@@ -10163,7 +10227,7 @@ see the Vcs-* tags in debian/control for
  {
  	struct tbl *tp;
  	struct tstate ts;
-@@ -1376,27 +1404,32 @@ search_path(const char *name, const char
+@@ -1376,27 +1410,32 @@ search_path(const char *name, const char
  }
  
  static int
@@ -10204,7 +10268,7 @@ see the Vcs-* tags in debian/control for
   */
  static int
  iosetup(struct ioword *iop, struct tbl *tp)
-@@ -1404,7 +1437,7 @@ iosetup(struct ioword *iop, struct tbl *
+@@ -1404,7 +1443,7 @@ iosetup(struct ioword *iop, struct tbl *
  	int u = -1;
  	char *cp = iop->ioname;
  	int iotype = iop->ioflag & IOTYPE;
@@ -10213,7 +10277,7 @@ see the Vcs-* tags in debian/control for
  	int flags = 0;
  	struct ioword iotmp;
  	struct stat statb;
-@@ -1418,9 +1451,9 @@ iosetup(struct ioword *iop, struct tbl *
+@@ -1418,9 +1457,9 @@ iosetup(struct ioword *iop, struct tbl *
  	iotmp.ioflag |= IONAMEXP;
  
  	if (Flag(FXTRACE)) {
@@ -10225,7 +10289,7 @@ see the Vcs-* tags in debian/control for
  	}
  
  	switch (iotype) {
-@@ -1448,7 +1481,7 @@ iosetup(struct ioword *iop, struct tbl *
+@@ -1448,7 +1487,7 @@ iosetup(struct ioword *iop, struct tbl *
  				 */
  				flags = O_WRONLY;
  				/* but check again after opening */
@@ -10234,7 +10298,7 @@ see the Vcs-* tags in debian/control for
  			}
  		} else {
  			/* >|file or set +C */
-@@ -1461,7 +1494,7 @@ iosetup(struct ioword *iop, struct tbl *
+@@ -1461,7 +1500,7 @@ iosetup(struct ioword *iop, struct tbl *
  		break;
  
  	case IOHERE:
@@ -10243,7 +10307,7 @@ see the Vcs-* tags in debian/control for
  		/* herein() returns -2 if error has been printed */
  		u = herein(iop, NULL);
  		/* cp may have wrong name */
-@@ -1470,18 +1503,19 @@ iosetup(struct ioword *iop, struct tbl *
+@@ -1470,18 +1509,19 @@ iosetup(struct ioword *iop, struct tbl *
  	case IODUP: {
  		const char *emsg;
  
@@ -10267,7 +10331,7 @@ see the Vcs-* tags in debian/control for
  			afree(sp, ATEMP);
  			return (-1);
  		}
-@@ -1496,7 +1530,8 @@ iosetup(struct ioword *iop, struct tbl *
+@@ -1496,7 +1536,8 @@ iosetup(struct ioword *iop, struct tbl *
  
  	if (do_open) {
  		if (Flag(FRESTRICTED) && (flags & O_CREAT)) {
@@ -10277,7 +10341,7 @@ see the Vcs-* tags in debian/control for
  			return (-1);
  		}
  		u = binopen3(cp, flags, 0666);
-@@ -1513,44 +1548,39 @@ iosetup(struct ioword *iop, struct tbl *
+@@ -1513,44 +1554,39 @@ iosetup(struct ioword *iop, struct tbl *
  	if (u < 0) {
  		/* herein() may already have printed message */
  		if (u == -1) {
@@ -10342,7 +10406,7 @@ see the Vcs-* tags in debian/control for
  			afree(sp, ATEMP);
  			if (iotype != IODUP)
  				close(u);
-@@ -1604,7 +1634,8 @@ hereinval(struct ioword *iop, int sub, c
+@@ -1604,7 +1640,8 @@ hereinval(struct ioword *iop, int sub, c
  		s->start = s->str = ccp;
  		source = s;
  		if (yylex(sub) != LWORD)
@@ -10352,7 +10416,7 @@ see the Vcs-* tags in debian/control for
  		source = osource;
  		ccp = evalstr(yylval.cp, DOSCALAR | DOHEREDOC);
  	}
-@@ -1639,9 +1670,8 @@ herein(struct ioword *iop, char **resbuf
+@@ -1639,9 +1676,8 @@ herein(struct ioword *iop, char **resbuf
  	 */
  	h = maketemp(ATEMP, TT_HEREDOC_EXP, &e->temps);
  	if (!(shf = h->shf) || (fd = binopen3(h->tffn, O_RDONLY, 0)) < 0) {
@@ -10364,7 +10428,7 @@ see the Vcs-* tags in debian/control for
  		if (shf)
  			shf_close(shf);
  		/* special to iosetup(): don't print error */
-@@ -1657,8 +1687,8 @@ herein(struct ioword *iop, char **resbuf
+@@ -1657,8 +1693,8 @@ herein(struct ioword *iop, char **resbuf
  	if (shf_close(shf) == -1) {
  		i = errno;
  		close(fd);
@@ -10375,7 +10439,7 @@ see the Vcs-* tags in debian/control for
  		/* special to iosetup(): don't print error */
  		return (-2);
  	}
-@@ -1671,7 +1701,7 @@ herein(struct ioword *iop, char **resbuf
+@@ -1671,7 +1707,7 @@ herein(struct ioword *iop, char **resbuf
   *	print the args in column form - assuming that we can
   */
  static const char *
@@ -10384,7 +10448,7 @@ see the Vcs-* tags in debian/control for
  {
  	static const char *read_args[] = {
  		Tread, Tdr, TREPLY, NULL
-@@ -1691,13 +1721,12 @@ do_selectargs(const char **ap, bool prin
+@@ -1691,13 +1727,12 @@ do_selectargs(const char **ap, bool prin
  		if (print_menu || !*str_val(global(TREPLY)))
  			pr_menu(ap);
  		shellf(Tf_s, str_val(global("PS3")));
@@ -10400,7 +10464,7 @@ see the Vcs-* tags in debian/control for
  	}
  }
  
-@@ -1758,7 +1787,7 @@ pr_menu(const char * const *ap)
+@@ -1758,7 +1793,7 @@ pr_menu(const char * const *ap)
  	smi.args = ap;
  	co.shf = shl_out;
  	co.linesep = '\n';
@@ -10409,7 +10473,7 @@ see the Vcs-* tags in debian/control for
  	print_columns(&co, n, select_fmt_entry, (void *)&smi,
  	    smi.num_width + 2 + aocts, smi.num_width + 2 + acols);
  }
-@@ -1802,7 +1831,7 @@ static Test_op
+@@ -1802,7 +1837,7 @@ static Test_op
  dbteste_isa(Test_env *te, Test_meta meta)
  {
  	Test_op ret = TO_NONOP;
@@ -10418,7 +10482,7 @@ see the Vcs-* tags in debian/control for
  	const char *p;
  
  	if (!*te->pos.wp)
-@@ -1840,7 +1869,7 @@ dbteste_isa(Test_env *te, Test_meta meta
+@@ -1840,7 +1875,7 @@ dbteste_isa(Test_env *te, Test_meta meta
  }
  
  static const char *
@@ -10427,7 +10491,7 @@ see the Vcs-* tags in debian/control for
  {
  	const char *s = *te->pos.wp;
  	int flags = DOTILDE | DOSCALAR;
-@@ -1866,5 +1895,33 @@ static void
+@@ -1866,5 +1901,33 @@ static void
  dbteste_error(Test_env *te, int offset, const char *msg)
  {
  	te->flags |= TEF_ERROR;
@@ -17333,7 +17397,7 @@ see the Vcs-* tags in debian/control for
 +#endif /* DEBUG */
 --- /dev/null
 +++ mksh-59c/mbsdcc.h
-@@ -0,0 +1,229 @@
+@@ -0,0 +1,243 @@
 +/*-
 + * MirBSD ISO C compiler toolkit (macros for mbsdint.h and others)
 + *
@@ -17341,7 +17405,7 @@ see the Vcs-* tags in debian/control for
 + */
 +
 +#ifndef SYSKERN_MBSDCC_H
-+#define SYSKERN_MBSDCC_H "$MirOS: src/bin/mksh/mbsdcc.h,v 1.9 2024/04/02 03:16:49 tg Exp $"
++#define SYSKERN_MBSDCC_H "$MirOS: src/bin/mksh/mbsdcc.h,v 1.10 2024/07/25 02:29:43 tg Exp $"
 +
 +/*
 + * Note: this header uses the SIZE_MAX (or similar) definitions
@@ -17349,6 +17413,9 @@ see the Vcs-* tags in debian/control for
 + * these before this header or include "mbsdint.h", which fixes
 + * up the corresponding definition.
 + *
++ * Place the inclusion of this after <sys/cdefs.h> or something
++ * that pulls it, for example <sys/types.h>.
++ *
 + * Furthermore, either include <stdlib.h> for abort(3), or pro‐
 + * vide an mbccABEND macro (preferred).
 + */
@@ -17371,6 +17438,17 @@ see the Vcs-* tags in debian/control for
 +#define offsetof(struc,memb)	__builtin_offsetof(struc, memb)
 +#endif
 +
++/* should be defined by <sys/cdefs.h> already */
++#ifndef __predict_true
++#if defined(__GNUC__) && (__GNUC__ >= 3) /* 2.96, but keep it simple here */
++#define __predict_true(exp)	__builtin_expect(!!(exp), 1)
++#define __predict_false(exp)	__builtin_expect(!!(exp), 0)
++#else
++#define __predict_true(exp)	(!!(exp))
++#define __predict_false(exp)	(!!(exp))
++#endif /* !GCC 3.x */
++#endif /* ndef(__predict_true) */
++
 +/* mbsdint.h replaces this with mbiSIZE_MAX */
 +#undef mbccSIZE_MAX
 +#if defined(SIZE_MAX)
@@ -17565,7 +17643,7 @@ see the Vcs-* tags in debian/control for
 +#endif /* !SYSKERN_MBSDCC_H */
 --- /dev/null
 +++ mksh-59c/mbsdint.h
-@@ -0,0 +1,1256 @@
+@@ -0,0 +1,1245 @@
 +/*-
 + * MirBSD sanitisation attempt for C integer madness
 + *
@@ -17573,7 +17651,7 @@ see the Vcs-* tags in debian/control for
 + */
 +
 +#ifndef SYSKERN_MBSDINT_H
-+#define SYSKERN_MBSDINT_H "$MirOS: src/bin/mksh/mbsdint.h,v 1.60 2024/04/02 03:16:50 tg Exp $"
++#define SYSKERN_MBSDINT_H "$MirOS: src/bin/mksh/mbsdint.h,v 1.61 2024/07/25 02:29:43 tg Exp $"
 +
 +/*
 + * cpp defines to set:
@@ -17601,7 +17679,7 @@ see the Vcs-* tags in debian/control for
 + *	<basetsd.h>		// on Windows®
 + *	<inttypes.h>		// some pre-C99
 + *	<stdint.h>		// ISO C99
-+ *	"mbsdcc.h"		// from this directory
++ *	"mbsdcc.h"		// from this directory, in this order
 + * … are included before this header, for full functionality.
 + */
 +
@@ -17658,17 +17736,6 @@ see the Vcs-* tags in debian/control for
 +#define MBSDINT_H_WANT_LONG_IN_SIZET 1
 +#endif
 +
-+/* should be in <sys/cdefs.h> via <limits.h> */
-+#ifndef __predict_true
-+#if defined(__GNUC__) && (__GNUC__ >= 3) /* 2.96, but keep it simple here */
-+#define __predict_true(exp)	__builtin_expect(!!(exp), 1)
-+#define __predict_false(exp)	__builtin_expect(!!(exp), 0)
-+#else
-+#define __predict_true(exp)	(!!(exp))
-+#define __predict_false(exp)	(!!(exp))
-+#endif /* !GCC 3.x */
-+#endif /* ndef(__predict_true) */
-+
 +/* expose SIZE_MAX if possible and provided, not guessed */
 +#ifndef SIZE_MAX
 +#if defined(SIZE_T_MAX)
@@ -18691,7 +18758,7 @@ see the Vcs-* tags in debian/control for
 +	(vl) -= (vr);							\
 +} while (/* CONSTCOND */ 0)
 +#define mbiCASmul(lim,vl,vr)	do {					\
-+	if (__predict_true((vr) >= 0) ? __predict_false((vr) != 0 &&	\
++	if (((vr) >= 0) ? __predict_false((vr) != 0 &&			\
 +	    mbi__sabovehalftype(lim ## _MAX, (vl), (vr)) && ((vl) < 0 ?	\
 +	    (vl) < (lim ## _MIN / (vr)) :				\
 +	    (vl) > (lim ## _MAX / (vr)))) :				\
@@ -23545,7 +23612,7 @@ see the Vcs-* tags in debian/control for
 -__RCSID("$MirOS: src/bin/mksh/os2.c,v 1.11 2020/10/01 21:13:45 tg Exp $");
 +#include "sh.h"
 +
-+__RCSID("$MirOS: src/bin/mksh/os2.c,v 1.21 2023/10/06 21:56:50 tg Exp $");
++__RCSID("$MirOS: src/bin/mksh/os2.c,v 1.23 2024/06/27 12:52:14 tg Exp $");
  
  struct a_s_arg {
  	union {
@@ -23610,6 +23677,15 @@ see the Vcs-* tags in debian/control for
  void
  os2_init(int *argcp, const char ***argvp)
  {
+@@ -287,7 +289,7 @@ access(const char *name, int mode)
+ #define MAX_X_SUFFIX_LEN	4
+ 
+ static const char *x_suffix_list[] =
+-    { "", ".ksh", ".exe", ".sh", ".cmd", ".com", ".bat", NULL };
++    { "", ".exe", ".ksh", ".sh", ".cmd", ".com", ".bat", NULL };
+ 
+ /* call fn() by appending executable extensions */
+ static int
 @@ -322,7 +324,7 @@ access_ex(int (*fn)(const char *, int),
  
  	arg.fn.i = fn;
@@ -23646,7 +23722,7 @@ see the Vcs-* tags in debian/control for
 -	tp = alloc(offsetof(struct temp, tffn[0]) + strlen(name) + 1, APERM);
 -	memcpy(tp->tffn, name, strlen(name) + 1);
 +	len = strlen(name) + 1U;
-+	tp = alloc(mbccFAMSZ(struct temp, tffn, len), APERM);
++	tp = alloc(mbccFAMsz(struct temp, tffn, len), APERM);
 +	memcpy(tp->tffn, name, len);
  	tp->next = templist;
  	templist = tp;
@@ -23707,7 +23783,7 @@ see the Vcs-* tags in debian/control for
 -#ifdef __dietlibc__
 -/* XXX imake style */
 -#define _BSD_SOURCE	/* live, BSD, live❣ */
-+#define MKSH_SH_H_ID "$MirOS: src/bin/mksh/sh.h,v 1.1031 2024/04/02 03:16:52 tg Exp $"
++#define MKSH_SH_H_ID "$MirOS: src/bin/mksh/sh.h,v 1.1032 2024/07/26 18:39:07 tg Exp $"
 +
 +#ifdef MKSH_USE_AUTOCONF_H
 +/* things that “should” have been on the command line */
@@ -23856,7 +23932,7 @@ see the Vcs-* tags in debian/control for
 -__RCSID("$MirOS: src/bin/mksh/sh.h,v 1.904 2020/10/31 03:53:06 tg Exp $");
 -#endif
 -#define MKSH_VERSION "R59 2020/10/31"
-+#define MKSH_VERSION "R59 2024/02/01"
++#define MKSH_VERSION "R59 2024/07/26"
  
 -/* arithmetic types: C implementation */
 -#if !HAVE_CAN_INTTYPES
@@ -27567,7 +27643,7 @@ see the Vcs-* tags in debian/control for
   * Copyright (c) 2003, 2004, 2005, 2006, 2007, 2008, 2009,
   *		 2011, 2012, 2013, 2014, 2015, 2016, 2017,
 - *		 2018, 2020
-+ *		 2018, 2020, 2021, 2023
++ *		 2018, 2020, 2021, 2023, 2024
   *	mirabilos <m@mirbsd.org>
   *
   * Provided that these terms and disclaimer and all copyright notices
@@ -27580,7 +27656,7 @@ see the Vcs-* tags in debian/control for
  #include "sh.h"
  
 -__RCSID("$MirOS: src/bin/mksh/syn.c,v 1.129 2020/10/31 01:21:58 tg Exp $");
-+__RCSID("$MirOS: src/bin/mksh/syn.c,v 1.152 2023/10/17 16:34:56 tg Exp $");
++__RCSID("$MirOS: src/bin/mksh/syn.c,v 1.153 2024/07/26 18:39:09 tg Exp $");
  
  struct nesting_state {
  	int start_token;	/* token than began nesting (eg, FOR) */
@@ -27834,16 +27910,23 @@ see the Vcs-* tags in debian/control for
  			yyerror("%s: bad identifier",
  			    c == FOR ? "for" : Tselect);
  		strdupx(t->str, ident, ATEMP);
-@@ -452,7 +458,7 @@ get_command(int cf, int sALIAS)
+@@ -452,8 +458,14 @@ get_command(int cf, int sALIAS)
  	case UNTIL:
  		nesting_push(&old_nesting, c);
  		t = newtp((c == WHILE) ? TWHILE : TUNTIL);
 -		t->left = c_list(sALIAS, true);
 +		t->left = c_list(sALIAS, Ja);
++		if (!t->left)
++			syntaxerr(NULL);
  		t->right = dogroup(sALIAS);
++#ifndef MKSH_SMALL
++		if (!t->right)
++			syntaxerr(NULL);
++#endif
  		nesting_pop(&old_nesting);
  		break;
-@@ -469,7 +475,7 @@ get_command(int cf, int sALIAS)
+ 
+@@ -469,7 +481,7 @@ get_command(int cf, int sALIAS)
  	case IF:
  		nesting_push(&old_nesting, c);
  		t = newtp(TIF);
@@ -27852,7 +27935,7 @@ see the Vcs-* tags in debian/control for
  		t->right = thenpart(sALIAS);
  		musthave(FI, KEYWORD|sALIAS);
  		nesting_pop(&old_nesting);
-@@ -497,7 +503,7 @@ get_command(int cf, int sALIAS)
+@@ -497,7 +509,7 @@ get_command(int cf, int sALIAS)
  
  	case FUNCTION:
  		musthave(LWORD, 0);
@@ -27861,7 +27944,7 @@ see the Vcs-* tags in debian/control for
  		break;
  	}
  
-@@ -553,7 +559,7 @@ dogroup(int sALIAS)
+@@ -553,7 +565,7 @@ dogroup(int sALIAS)
  		c = ORD('}');
  	else
  		syntaxerr(NULL);
@@ -27870,7 +27953,7 @@ see the Vcs-* tags in debian/control for
  	musthave(c, KEYWORD|sALIAS);
  	return (list);
  }
-@@ -565,7 +571,7 @@ thenpart(int sALIAS)
+@@ -565,7 +577,7 @@ thenpart(int sALIAS)
  
  	musthave(THEN, KEYWORD|sALIAS);
  	t = newtp(0);
@@ -27879,7 +27962,7 @@ see the Vcs-* tags in debian/control for
  	if (t->left == NULL)
  		syntaxerr(NULL);
  	t->right = elsepart(sALIAS);
-@@ -579,13 +585,13 @@ elsepart(int sALIAS)
+@@ -579,13 +591,13 @@ elsepart(int sALIAS)
  
  	switch (token(KEYWORD|sALIAS|CMDASN)) {
  	case ELSE:
@@ -27895,7 +27978,7 @@ see the Vcs-* tags in debian/control for
  		t->right = thenpart(sALIAS);
  		return (t);
  
-@@ -655,7 +661,7 @@ casepart(int endtok, int sALIAS)
+@@ -655,7 +667,7 @@ casepart(int endtok, int sALIAS)
  	t->vars = (char **)XPclose(ptns);
  	musthave(ORD(')'), 0);
  
@@ -27904,7 +27987,7 @@ see the Vcs-* tags in debian/control for
  
  	/* initialise to default for ;; or omitted */
  	t->u.charflag = ORD(';');
-@@ -681,7 +687,7 @@ casepart(int endtok, int sALIAS)
+@@ -681,7 +693,7 @@ casepart(int endtok, int sALIAS)
  static struct op *
  function_body(char *name, int sALIAS,
      /* function foo { ... } vs foo() { .. } */
@@ -27913,7 +27996,7 @@ see the Vcs-* tags in debian/control for
  {
  	char *sname, *p;
  	struct op *t;
-@@ -693,9 +699,10 @@ function_body(char *name, int sALIAS,
+@@ -693,9 +705,10 @@ function_body(char *name, int sALIAS,
  	 * have allowed more; the following were never allowed:
  	 *	NUL TAB NL SP " $ & ' ( ) ; < = > \ ` |
  	 * C_QUOTE|C_SPC covers all but adds # * ? [ ]
@@ -27925,7 +28008,7 @@ see the Vcs-* tags in debian/control for
  			yyerror(Tinvname, sname, Tfunction);
  
  	/*
-@@ -710,7 +717,7 @@ function_body(char *name, int sALIAS,
+@@ -710,7 +723,7 @@ function_body(char *name, int sALIAS,
  			ACCEPT;
  			musthave(ORD(/*(*/ ')'), 0);
  			/* degrade to POSIX function */
@@ -27934,7 +28017,7 @@ see the Vcs-* tags in debian/control for
  		}
  		musthave(ORD('{' /*}*/), CONTIN|KEYWORD|sALIAS);
  		REJECT;
-@@ -718,7 +725,7 @@ function_body(char *name, int sALIAS,
+@@ -718,7 +731,7 @@ function_body(char *name, int sALIAS,
  
  	t = newtp(TFUNCT);
  	t->str = sname;
@@ -27943,7 +28026,7 @@ see the Vcs-* tags in debian/control for
  	t->lineno = source->line;
  
  	if ((t->left = get_command(CONTIN, sALIAS)) == NULL) {
-@@ -788,37 +795,37 @@ static const struct tokeninfo {
+@@ -788,37 +801,37 @@ static const struct tokeninfo {
  	short reserved;
  } tokentab[] = {
  	/* Reserved words */
@@ -28010,7 +28093,7 @@ see the Vcs-* tags in debian/control for
  };
  
  void
-@@ -924,14 +931,12 @@ newtp(int type)
+@@ -924,14 +937,12 @@ newtp(int type)
  }
  
  struct op *
@@ -28026,7 +28109,7 @@ see the Vcs-* tags in debian/control for
  	yyparse(doalias);
  	return (outtree);
  }
-@@ -948,7 +953,6 @@ inalias(struct source *s)
+@@ -948,7 +959,6 @@ inalias(struct source *s)
  	return (0);
  }
  
@@ -28034,7 +28117,7 @@ see the Vcs-* tags in debian/control for
  /*
   * Order important - indexed by Test_meta values
   * Note that ||, &&, ( and ) can't appear in as unquoted strings
-@@ -977,7 +981,7 @@ static Test_op
+@@ -977,7 +987,7 @@ static Test_op
  dbtestp_isa(Test_env *te, Test_meta meta)
  {
  	int c = tpeek(CMDASN | (meta == TM_BINOP ? 0 : CONTIN));
@@ -28043,7 +28126,7 @@ see the Vcs-* tags in debian/control for
  	char *save = NULL;
  	Test_op ret = TO_NONOP;
  
-@@ -1020,7 +1024,7 @@ dbtestp_isa(Test_env *te, Test_meta meta
+@@ -1020,7 +1030,7 @@ dbtestp_isa(Test_env *te, Test_meta meta
  
  static const char *
  dbtestp_getopnd(Test_env *te, Test_op op MKSH_A_UNUSED,
@@ -28052,7 +28135,7 @@ see the Vcs-* tags in debian/control for
  {
  	int c = tpeek(CMDASN);
  
-@@ -1036,7 +1040,7 @@ dbtestp_getopnd(Test_env *te, Test_op op
+@@ -1036,7 +1046,7 @@ dbtestp_getopnd(Test_env *te, Test_op op
  static int
  dbtestp_eval(Test_env *te MKSH_A_UNUSED, Test_op op MKSH_A_UNUSED,
      const char *opnd1 MKSH_A_UNUSED, const char *opnd2 MKSH_A_UNUSED,
@@ -28061,7 +28144,7 @@ see the Vcs-* tags in debian/control for
  {
  	return (1);
  }
-@@ -1057,41 +1061,49 @@ dbtestp_error(Test_env *te, int offset,
+@@ -1057,41 +1067,49 @@ dbtestp_error(Test_env *te, int offset,
  }
  
  #if HAVE_SELECT
@@ -28103,7 +28186,8 @@ see the Vcs-* tags in debian/control for
 +			mbiCAUmul(time_t, tt, 10);
 +			mbiCAUadd(tt, ksh_numdig(*s));
 +			++s;
-+		}
+ 		}
+-		tv->tv_sec = tt.tv_sec;
 +		mbiCAAlet(tv->tv_sec, time_t, tt);
 +	} else {
 +		mbiHUGE_S tt = 0;
@@ -28112,8 +28196,7 @@ see the Vcs-* tags in debian/control for
 +			mbiCAPmul(mbiHUGE_S, tt, 10);
 +			mbiCAPadd(mbiHUGE_S, tt, ksh_numdig(*s));
 +			++s;
- 		}
--		tv->tv_sec = tt.tv_sec;
++		}
 +		mbiCASlet(time_t, tv->tv_sec, mbiHUGE_S, tt);
  	}
 +#undef mbiCfail
@@ -28131,7 +28214,7 @@ see the Vcs-* tags in debian/control for
  	}
  
  	/* parse decimal fraction */
-@@ -1107,11 +1119,11 @@ parse_usec(const char *s, struct timeval
+@@ -1107,11 +1125,11 @@ parse_usec(const char *s, struct timeval
  		++s;
  	if (*s) {
  		errno = EINVAL;
@@ -28145,7 +28228,7 @@ see the Vcs-* tags in debian/control for
  }
  #endif
  
-@@ -1152,7 +1164,7 @@ yyrecursive(int subtype)
+@@ -1152,7 +1170,7 @@ yyrecursive(int subtype)
  	e->yyrecursive_statep = ys;
  	/* we use TPAREN as a helper container here */
  	t = nested(TPAREN, stok, etok, ALIAS);
@@ -28154,7 +28237,7 @@ see the Vcs-* tags in debian/control for
  
  	/* t->left because nested(TPAREN, ...) hides our goodies there */
  	cp = snptreef(NULL, 0, Tf_T, t->left);
-@@ -1162,7 +1174,7 @@ yyrecursive(int subtype)
+@@ -1162,7 +1180,7 @@ yyrecursive(int subtype)
  }
  
  void
@@ -28163,7 +28246,7 @@ see the Vcs-* tags in debian/control for
  {
  	struct yyrecursive_state *ys;
  
-@@ -1182,3 +1194,284 @@ yyrecursive_pop(bool popall)
+@@ -1182,3 +1200,284 @@ yyrecursive_pop(bool popall)
  	if (popall)
  		goto popnext;
  }
@@ -28464,7 +28547,7 @@ see the Vcs-* tags in debian/control for
  #include "sh.h"
  
 -__RCSID("$MirOS: src/bin/mksh/tree.c,v 1.100 2020/10/31 04:28:54 tg Exp $");
-+__RCSID("$MirOS: src/bin/mksh/tree.c,v 1.113 2022/02/19 21:22:02 tg Exp $");
++__RCSID("$MirOS: src/bin/mksh/tree.c,v 1.114 2024/07/26 18:34:58 tg Exp $");
  
  #define INDENT	8
  
@@ -29094,6 +29177,15 @@ see the Vcs-* tags in debian/control for
  		goto out;
  	}
  	dumpioact(shf, t);
+@@ -1059,7 +1300,7 @@ dumptree(struct shf *shf, struct op *t)
+ 		shf_putc('\n', shf);
+ 		dumptree(shf, t->left);
+ /* middumprightandout: (unused) */
+-		shf_fprintf(shf, "/%s:", name);
++		shf_fprintf(shf, " /%s:", name);
+  dumprightandout:
+ 		t = t->right;
+ 		goto dumpandout;
 @@ -1179,4 +1420,47 @@ dumptree(struct shf *shf, struct op *t)
  	shf_fprintf(shf, /*{*/ " /%s}\n", name);
  	--nesting;
diff -pruN 59c-38/debian/rules 59c-39/debian/rules
--- 59c-38/debian/rules	2024-07-04 23:01:13.000000000 +0000
+++ 59c-39/debian/rules	2024-08-18 23:07:51.000000000 +0000
@@ -113,8 +113,10 @@ execute_after_dh_installdocs-arch:
 	rm -f debian/mksh/usr/share/doc/mksh/README.Debian
 	cp builddir/README.Debian.gz debian/mksh/usr/share/doc/mksh/
 
-override_dh_builddeb:
-	bash debian/mkdeb
+execute_before_dh_installdeb:
+	if command -v dh_movetousr >/dev/null 2>&1; then dh_movetousr; fi
+
+execute_after_dh_builddeb-arch:
 	#-
 	cat builddir/loglibc.txt
 	gzip -d <builddir/README.Debian.gz | sed --posix \
